Package: stPipe
Type: Package
Title: Upstream pre-processing for Sequencing-Based Spatial
        Transcriptomics
Version: 1.3.0
Authors@R: c(person("Yang", "Xu", role=c("aut", "cre"), email="xu.ya@wehi.edu.au", comment=c(ORCID="0009-0008-3274-6516")), 
        person("Callum", "Sargeant", role=c("aut"), email="sargeant.ca@wehi.edu.au"), 
        person("Shian", "Su", role=c("aut"), email="su.s@wehi.edu.au"), 
        person("Luyi", "Tian", role=c("aut"), email="tian.l@wehi.edu.au"), 
        person("Yunshun", "Chen", role=c("ctb"), email="yuchen@wehi.edu.au"), 
        person("Matthew", "Ritchie", role=c("ctb", "fnd"), email="mritchie@wehi.edu.au"))
biocViews: ImmunoOncology, Software, Sequencing, RNASeq,
        GeneExpression, SingleCell, Visualization, SequenceMatching,
        Preprocessing, QualityControl, GenomeAnnotation, DataImport,
        Spatial, Transcriptomics, Clustering
Description: This package serves as an upstream pipeline for pre-processing sequencing-based spatial transcriptomics data. Functions includes FASTQ trimming, BAM file reformatting, index building, spatial barcode detection, demultiplexing, gene count matrix generation with UMI deduplication, QC, and revelant visualization. Config is an essential input for most of the functions which aims to improve reproducibility.
Depends: R (>= 4.5.0)
Imports: basilisk, data.table, DropletUtils, dplyr, ggplot2, methods,
        pbmcapply, reticulate, rmarkdown, Rcpp, Rhtslib, Rsubread,
        Rtsne, Seurat, SeuratObject, scPipe, shiny,
        SummarizedExperiment, SingleCellExperiment, SpatialExperiment,
        stats, umap, yaml
LinkingTo: Rcpp, Rhdf5lib, testthat, Rhtslib
SystemRequirements: GNU make
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.2
URL: https://github.com/mritchielab/stPipe
BugReports: https://github.com/mritchielab/stPipe/issues/new
Suggests: knitr, plotly, BiocStyle, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/stPipe
git_branch: devel
git_last_commit: 287ceed
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: yes
Packaged: 2026-04-30 00:52:47 UTC; biocbuild
Author: Yang Xu [aut, cre] (ORCID: <https://orcid.org/0009-0008-3274-6516>),
  Callum Sargeant [aut],
  Shian Su [aut],
  Luyi Tian [aut],
  Yunshun Chen [ctb],
  Matthew Ritchie [ctb, fnd]
Maintainer: Yang Xu <xu.ya@wehi.edu.au>

# stPipe

<img  src="vignettes/stPipe_logo.png">

The stPipe package provides a comprehensive pipeline for preprocessing sequencing-based spatial transcriptomics data, including 10X Visium, BGI Stereo-seq, Slide-seq, and Curio-seeker.

## Installation

### From Bioconductor (recommended approach)

```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("stPipe")
```

### From GitHub (Developmental version)

```
if (!require("devtools", quietly = TRUE))
    install.packages("devtools")
devtools::install_github("mritchielab/stPipe")

or

if (!require("remotes", quietly = TRUE))
    install.packages("remotes")
remotes::install_github("mritchielab/stPipe")
```

The sample data is downsampled from a 10X Visium mouse spleen sample (Sample 709). It is a probe-based, FFPE tissue dataset generated from paired-end FASTQ files. The data can be downloaded from [Zenodo](https://zenodo.org/records/14920583), and a detailed sample description is available in the [SpatialBench paper](https://www.biorxiv.org/content/10.1101/2024.03.13.584910v1.abstract).

Sample HTML report for demo data can be found [here](https://github.com/YangXuuu/demo_data_stPipe/blob/main/report.html).

#####################################################
# Generate HTML Report for upstream results
#####################################################

#' @name Run_HTML
#' @title HTML report generation in RMarkDown format
#'
#' @description This function generates a HTML report of stPipe upstream processing steps in Rmarkdown format. It extracts plots in the result directory and outputs them in the whole report with corresponding explanation.
#' @examples
#' ## @example
#' temp_dir <- tempdir()
#' dummy_gene_count <- data.frame(GeneA = c(10, 20), GeneB = c(5, 15))
#' rownames(dummy_gene_count) <- c("spot1", "spot2")
#' write.csv(dummy_gene_count, file = file.path(temp_dir, "gene_count.csv"), row.names = TRUE)
#' png_files <- c("Mapping_statistics_plot.png", "UMI_duplication_plot.png",
#'              "Barcode_demultiplexing_plot.png", "Spatial_Heatmap_of_UMI_Count_raw.png",
#'                          "Spatial_Heatmap_of_UMI_Count_log.png", "Threshold.png")
#'                          for (f in png_files) {
#'                            fileConn <- file(file.path(temp_dir, f))
#'                              writeLines("dummy image content", fileConn)
#'                                close(fileConn)}
#' html_files <- c("tsne_interactive.html", "umap_interactive.html")
#' for (f in html_files) {
#'  fileConn <- file(file.path(temp_dir, f))
#'  writeLines("<html>dummy interactive html</html>", fileConn)
#'  close(fileConn)}
#' dummy_rmd <- paste(
#'  "Report for stPipe",
#'  "Mapping Statistics: <<Mapping_statistics_plot>>",
#'  "UMI Duplication: <<UMI_duplication_plot>>",
#'  "Barcode Demultiplexing: <<Barcode_demultiplexing_plot>>",
#'  "Spatial Heatmap Raw: <<Spatial_Heatmap_of_UMI_Count_raw>>",
#'  "Spatial Heatmap Log: <<Spatial_Heatmap_of_UMI_Count_log>>",
#'  "Threshold: <<Threshold>>",
#'  "tSNE Interactive: <<tsne_interactive>>",
#'  "UMAP Interactive: <<umap_interactive>>",
#'  sep = "\n"
#')
#' dummy_template_path <- file.path(temp_dir, "stPipe_Report_Skeleton.Rmd")
#' writeLines(dummy_rmd, dummy_template_path)
#' Run_HTML_test <- function(path) {
#'  rmd_template_path <- dummy_template_path
#'  if (rmd_template_path == "") {
#'    stop("Template file not found. Please check if it's properly installed in your package.")
#'  }
#' rmd_template <- readLines(rmd_template_path)
#'  gene_count <- read.csv(file.path(path, "gene_count.csv"), row.names = 1)
#'    Mapping_statistics_plot <- normalizePath(file.path(path, "Mapping_statistics_plot.png"))
#'  UMI_duplication_plot <- normalizePath(file.path(path, "UMI_duplication_plot.png"))
#'  Barcode_demultiplexing_plot <- normalizePath(file.path(path, "Barcode_demultiplexing_plot.png"))
#'  Spatial_Heatmap_of_UMI_Count_raw <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_raw.png"))
#'  Spatial_Heatmap_of_UMI_Count_log <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_log.png"))
#'  Threshold <- normalizePath(file.path(path, "Threshold.png"))
#'  tsne_interactive <- normalizePath(file.path(path, "tsne_interactive.html"))
#'  umap_interactive <- normalizePath(file.path(path, "umap_interactive.html"))
#'  rmd_content <- gsub("<<path>>", path, rmd_template)
#'  rmd_content <- gsub("<<Mapping_statistics_plot>>", Mapping_statistics_plot, rmd_content)
#'  rmd_content <- gsub("<<UMI_duplication_plot>>", UMI_duplication_plot, rmd_content)
#'  rmd_content <- gsub("<<Barcode_demultiplexing_plot>>", Barcode_demultiplexing_plot, rmd_content)
#'  rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_raw>>", Spatial_Heatmap_of_UMI_Count_raw, rmd_content)
#'  rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_log>>", Spatial_Heatmap_of_UMI_Count_log, rmd_content)
#'  rmd_content <- gsub("<<Threshold>>", Threshold, rmd_content)
#'  rmd_content <- gsub("<<tsne_interactive>>", tsne_interactive, rmd_content)
#'  rmd_content <- gsub("<<umap_interactive>>", umap_interactive, rmd_content)
#'  rmd_file <- file.path(path, "report.Rmd")
#'  writeLines(rmd_content, rmd_file)
#'  rmarkdown::render(rmd_file, output_file = file.path(path, "report.html"))}
#' Run_HTML_test(temp_dir)
#' @param path Path to where results are stored, including the ones obtained from 'Run_ST', 'Run_loc_match', 'Run_Vis', and 'Run_Clustering'.
#' @return Generated HTML report in RMarkDown format.
#' @importFrom rmarkdown render
#' @export

Run_HTML <- function(path) {

  rmd_template_path <- system.file("rmarkdown/templates/stpipe-report/skeleton/stPipe_Report_Skeleton.Rmd", package = "stPipe")
  if (rmd_template_path == "") {
    stop("Template file not found. Please check if it's properly installed in your package.")
  }

  rmd_template <- readLines(rmd_template_path)

  # gene count information
  gene_count <- utils::read.csv(file.path(path, "gene_count.csv"), row.names = 1)
  #filtered_gene_count <- read.csv(file.path(path, "upstream_QC/filtered_gene_count.csv"), row.names = 1)

  # barplot for QC filtering
  #total_gene_count <- length(colnames(gene_count))
  #filtered_gene_count_len <- length(colnames(filtered_gene_count))
  #filtered_out <- total_gene_count - filtered_gene_count_len

  # obtain plot path
  #bar_plot_path <- normalizePath(file.path(path, "gene_count_diff_plot.png"))
  Mapping_statistics_plot <- normalizePath(file.path(path, "Mapping_statistics_plot.png"))
  UMI_duplication_plot <- normalizePath(file.path(path, "UMI_duplication_plot.png"))
  Barcode_demultiplexing_plot <- normalizePath(file.path(path, "Barcode_demultiplexing_plot.png"))
  Spatial_Heatmap_of_UMI_Count_raw <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_raw.png"))
  Spatial_Heatmap_of_UMI_Count_log <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_log.png"))
  Threshold <- normalizePath(file.path(path, "Threshold.png"))
  tsne_interactive <- normalizePath(file.path(path, "tsne_interactive.html"))
  umap_interactive <- normalizePath(file.path(path, "umap_interactive.html"))

  #png(bar_plot_path)
  #barplot(c(total_gene_count, filtered_gene_count_len),
  #        names.arg = c("Original", "Filtered"),
  #        main = "Number of Spatial location Before and After QC",
  #        col = c("red", "green"))
  #dev.off()
  #description_text <- sprintf("After the quality control step, %d spots/bins/beads have been filtered out due to their low quality and %d are remained.",
  #                            filtered_out, filtered_gene_count_len)

  # replace placeholder
  #rmd_content <- gsub("<<bar_plot_path>>", bar_plot_path, rmd_content)
  #rmd_content <- gsub("<<filtered_out>>", filtered_out, rmd_content)
  #rmd_content <- gsub("<<filtered_gene_count_len>>", filtered_gene_count_len, rmd_content)
  #rmd_content <- gsub("description_text", description_text, rmd_content
  rmd_content <- gsub("<<path>>", path, rmd_template)
  rmd_content <- gsub("<<Mapping_statistics_plot>>", Mapping_statistics_plot, rmd_content)
  rmd_content <- gsub("<<UMI_duplication_plot>>", UMI_duplication_plot, rmd_content)
  rmd_content <- gsub("<<Barcode_demultiplexing_plot>>", Barcode_demultiplexing_plot, rmd_content)
  rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_raw>>", Spatial_Heatmap_of_UMI_Count_raw, rmd_content)
  rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_log>>", Spatial_Heatmap_of_UMI_Count_log, rmd_content)
  rmd_content <- gsub("<<Threshold>>", Threshold, rmd_content)
  rmd_content <- gsub("<<tsne_interactive>>", tsne_interactive, rmd_content)
  rmd_content <- gsub("<<umap_interactive>>", umap_interactive, rmd_content)

  # write into new RMarkdown file
  rmd_file <- file.path(path, "report.Rmd")
  writeLines(rmd_content, rmd_file)

  # generate HTML report under specified path
  rmarkdown::render(rmd_file, output_file = file.path(path, "report.html"))
}

# define Basilisk environment
stPipe_env <- basilisk::BasiliskEnvironment(
  envname = "stPipe_env",
  pkgname = "stPipe",
  packages = c("python=3.9"),
  channels = c("conda-forge"),
  pip = c(
    "numpy==1.22.1",
    "pandas==1.4.3",
    "pysam==0.22.1",
    "opencv-python==4.5.5.64"
  )
)

#####################################################
# Perform spatial location matching for gene count matrix
#####################################################

#' @name Run_Loc_Match
#' @title Match spatial location After Pre-Processing for Sequencing-Based Spatial Transcriptomics
#'
#' @description This function matches spatial coordinates for sST data after upstream pre-processing.
#' 'Run_loc_match' can either map the technology coordination system (such as spot in Visium coordination, bead in Slide-seq coordination)
#' or compute pixel for each spot and map the pixel information back to the image (only for Visium)
#'
#' @param config Path to the YAML configuration file.
#' @param pixel Computing spot pixel or not. If yes, compute pixel for each spot and map back to image; if not, map the Visium coordination system. Defaults to FALSE.
#' @param show.config Logical value indicating whether to print the configuration. Defaults to TRUE.
#' @return A data frame contains gene count matrix with spatial coordinates
#' @examples
#' data_dir <- tempdir()
#' output_dir <- file.path(tempdir(), "Run_Loc_Match_output")
#' if (!dir.exists(output_dir)) dir.create(output_dir, recursive = TRUE)
#' sample_index <- data.frame(
#'   barcode_sequence = c("BC001", "BC002", "BC003"),
#'   cell_name = c("CELL_1", "CELL_2", "CELL_3"),
#'   stringsAsFactors = FALSE
#' )
#' write.csv(sample_index, file = file.path(output_dir, "sample_index.csv"), row.names = FALSE)
#' gene_count <- data.frame(
#'   gene_id = c("gene1", "gene2"),
#'   CELL_1 = c(10, 5),
#'   CELL_2 = c(20, 10),
#'   CELL_3 = c(30, 15),
#'   stringsAsFactors = FALSE
#' )
#' write.csv(gene_count, file = file.path(output_dir, "gene_count.csv"), row.names = FALSE)
#' config_list <- list(
#'   output_directory = output_dir,
#'   data_directory = data_dir,
#'   technology_version = "Visium_probe_v1",
#'   visium_coordination = "V1"
#' )
#' config_file <- tempfile(fileext = ".yml")
#' yaml::write_yaml(config_list, config_file)
#' result <- Run_Loc_Match(
#'   config = config_file,
#'   pixel = FALSE,
#'   show.config = FALSE
#' )
#' @export
#' @importFrom utils read.csv

Run_Loc_Match <- function(config, pixel = FALSE, show.config = TRUE) {

  config <- yaml::read_yaml(config)
  if (show.config) {
    message(config)
  }

  output_directory <- as.character(config$output_directory)
  data_directory <- as.character(config$data_directory)
  technology_version <- as.character(config$technology_version)
  visium_coordination <- as.character(config$visium_coordination)
  image_path <- as.character(config$image_path)
  bead_location <- as.character(config$bead_location)

  # New directory named 'upstream_QC' under the output directory
  qc_dir <- file.path(output_directory, "upstream_QC")
  if (!dir.exists(qc_dir)) {
    dir.create(qc_dir)
  }

  # Match extracted spatial barcode to x & y coordination
  if (grepl("Visium", technology_version)) {
    coordinates <- switch(
      visium_coordination,
      "V1" = readRDS(system.file("extdata", "visium_v1_coordinates.rds", package = "stPipe")),
      "V2" = readRDS(system.file("extdata", "visium_v2_coordinates.rds", package = "stPipe")),
      "V3" = readRDS(system.file("extdata", "visium_v3_coordinates.rds", package = "stPipe")),
      "V4" = readRDS(system.file("extdata", "visium_v4_coordinates.rds", package = "stPipe")),
      "V5" = readRDS(system.file("extdata", "visium_v5_coordinates.rds", package = "stPipe")),
      stop("Unsupported technology version")
    )
    message("Heading Coordinates for Visium:")
    message(utils::head(coordinates))
    message("Start mapping coordination...")
    colnames(coordinates) <- c("barcode_sequence", "X_coordinate", "Y_coordinate")
    annotation_file <- file.path(output_directory, "sample_index.csv")
    annotation <- utils::read.csv(annotation_file, stringsAsFactors = FALSE)
    matched_data <- merge(annotation, coordinates, by = "barcode_sequence", all.x = TRUE)
    matched_data <- matched_data[stats::complete.cases(matched_data), ]

    gene_count_file <- file.path(output_directory, "gene_count.csv")
    gene_count <- utils::read.csv(gene_count_file)
    sum_counts <- colSums(gene_count[, -1])
    matched_data$UMI_count <- as.numeric(sum_counts[match(matched_data$cell_name, names(sum_counts))])
  } else if (technology_version == "Slideseq" || technology_version == "Curio-seeker") {
    coordinates <- utils::read.csv(bead_location, header = TRUE, stringsAsFactors = FALSE)
    message("Heading Coordinates for Slideseq or Curio-seeker:")
    message(utils::head(coordinates))
    message("Start mapping coordination...")
    colnames(coordinates) <- c("barcode_sequence", "X_coordinate", "Y_coordinate")

    # Read annotation and gene count data
    annotation_file <- file.path(output_directory, "sample_index.csv")
    annotation <- utils::read.csv(annotation_file, stringsAsFactors = FALSE)
    matched_data <- merge(annotation, coordinates, by = "barcode_sequence", all.x = TRUE)
    matched_data <- matched_data[stats::complete.cases(matched_data), ]

    gene_count_file <- file.path(output_directory, "gene_count.csv")
    gene_count <- utils::read.csv(gene_count_file)
    sum_counts <- colSums(gene_count[, -1])
    matched_data$UMI_count <- as.numeric(sum_counts[match(matched_data$cell_name, names(sum_counts))])

  } else if (technology_version == "Stereoseq") {
    message("Processing Stereoseq technology...")

    # Load sample_index
    sample_index_path <- file.path(output_directory, "sample_index.csv")
    sample_index <- data.table::fread(sample_index_path)

    # Initialize x and y columns
    sample_index$x <- NA
    sample_index$y <- NA

    # Process R1 file
    r1_path <- list.files(data_directory, pattern = "R1", full.names = TRUE)
    decompressed_r1 <- tempfile(fileext = ".fq")
    system(paste("gzip -dc", shQuote(r1_path), ">", decompressed_r1))

    r1_content <- data.table::fread(decompressed_r1, sep = "\n", header = FALSE)
    r1_headers <- r1_content[seq(1, nrow(r1_content), 4), ]
    r1_barcodes <- r1_content[seq(2, nrow(r1_content), 4), ]

    r1_table <- data.frame(
      read_id = sub("^@(.*)/.*$", "\\1", r1_headers[[1]]),
      barcode = substr(r1_barcodes[[1]], 1, 25)
    )

    # Process demultiplexed file
    demultiplexed_path <- file.path(output_directory, "demultiplexed.fq")
    demultiplexed <- data.table::fread(demultiplexed_path, sep = "\n", header = FALSE)
    demultiplexed_headers <- demultiplexed[seq(1, nrow(demultiplexed), 4), ]

    demultiplexed_table <- do.call(rbind, lapply(demultiplexed_headers[[1]], function(line) {
      read_id <- sub("^@(.*)[:_].*$", "\\1", line)
      coords <- regmatches(line, gregexpr("x\\d+|y\\d+", line, perl = TRUE))[[1]]
      if (length(coords) == 2) {
        return(data.frame(
          read_id = read_id,
          x = as.integer(sub("x", "", coords[1])),
          y = as.integer(sub("y", "", coords[2]))
        ))
      } else {
        return(data.frame(read_id = read_id, x = NA, y = NA))
      }
    }))

    # Merge R1 and demultiplexed
    matched_table <- merge(
      r1_table,
      demultiplexed_table,
      by = "read_id",
      all.x = TRUE
    )

    # Use read_id to match barcode_sequence in sample_index
    final_table <- merge(
      sample_index,
      matched_table[, c("barcode", "x", "y")],
      by.x = "barcode_sequence",
      by.y = "barcode",
      all.x = TRUE
    )

    # Process gene count
    gene_count_file <- file.path(output_directory, "gene_count.csv")
    gene_count <- data.table::fread(gene_count_file)
    umi_sums <- colSums(gene_count[, -1])
    final_table$UMI_count <- umi_sums[match(final_table$cell_name, names(umi_sums))]

    # Update column names
    colnames(final_table)[2] <- "spatial_name"
    final_table$spatial_name <- gsub("^CELL_", "SPATIAL_", final_table$spatial_name)
    colnames(gene_count) <- gsub("^CELL_", "SPATIAL_", colnames(gene_count))

    return(list(matched_data = final_table, gene_count = gene_count))
  }

  else {
    stop("Unknown technology_version in config file, please check again.")
  }

  # Compute pixel information if pixel = T
  if (pixel) {
    message("Start computing pixel information...")

    # set R_PACKAGE_DIR environment variable
    r_package_dir <- system.file(package = "stPipe")
    #Sys.setenv(R_PACKAGE_DIR = system.file(package = "stPipe"))
    pixel_output_csv <- file.path(qc_dir, "mapped_pixel.csv")

    # Call Python script
    basilisk::basiliskRun(
      env = stPipe:::stPipe_env,
      fun = function(test_img_fn, output_dir) {
        Visium_pixel <- reticulate::import_from_path("Visium_pixel", system.file("python", package = "stPipe"))
        Visium_pixel$main(test_img_fn, output_dir)
      },
      test_img_fn = image_path,
      output_dir = qc_dir
    )

    # Load pixel coordinates
    pixel_data <- utils::read.csv(pixel_output_csv, stringsAsFactors = FALSE)

    # Read ref_pos.csv internally
    ref_pos_path <- system.file("extdata", "ref_pos.csv", package = "stPipe")
    ref_pos <- utils::read.csv(ref_pos_path, header = FALSE, stringsAsFactors = FALSE)
    colnames(ref_pos) <- c("barcode_sequence", "in_tissue", "X_coordinate", "Y_coordinate", "x", "y")
    ref_pos <- ref_pos[-1, ]  # Remove the first row

    # Remove "-1" from barcode_sequence
    ref_pos$barcode_sequence <- gsub("-1$", "", ref_pos$barcode_sequence)
    # Add barcode_sequence to pixel_data
    pixel_data$barcode_sequence <- ref_pos$barcode_sequence
    # Merge pixel_data with matched_data
    matched_data <- merge(matched_data, pixel_data, by = "barcode_sequence", all.x = TRUE)
    colnames(matched_data)[7:8] <- c("Y_pixel", "X_pixel")
  }

  colnames(matched_data)[2] <- c("spatial_name")
  matched_data$spatial_name <- gsub("^CELL_", "SPATIAL_", matched_data$spatial_name)

  gene_count <- utils::read.csv(gene_count_file)
  rownames(gene_count) <- gene_count$gene_id
  gene_count$gene_id <- NULL
  colnames(gene_count) <- gsub("^CELL_", "SPATIAL_", colnames(gene_count))
  return(list(matched_data = matched_data, gene_count = gene_count))
}

#' stPipe: A package for pre-processing sequencing-based spatial transcriptomics data.
#'
#' @description The stPipe will do spatial barcode demultiplexing, UMI deduplication, spatial location matching and quality control on
#' fastq data generated from all mainstream protocols
#'
#' @section stPipe functions:
#' The stPipe functions Run_ST, Run_loc_match, Run_QC, Run_Vis, Run_Clustering, Run_create_obj, Run_HTML, Run_Interactive
#'
#'
#' @author Yang Xu <xu.ya@wehi.edu.au>
#' @docType package
#' @name stPipe
#' @import Rhtslib
#' @import SingleCellExperiment
#' @import SpatialExperiment
#' @import Rcpp
#' @importFrom methods as
#' @useDynLib stPipe, .registration = TRUE
#' @aliases stPipe stPipe-package
NULL

# This dummy function definition is included with the package to ensure that
# 'tools::package_native_routine_registration_skeleton()' generates the required
# registration info for the 'run_testthat_tests' symbol.
(function() {
  .Call("run_testthat_tests", FALSE, PACKAGE = "stPipe")
})

#####################################################
# Visualization for sST upstream results
#####################################################

#' @name Run_Visualization
#' @title Visualize pre-processed sST data
#' @description This function visualizes both spatial-level and read-level information either before or after the 'Run_QC' step. It outputs raw and log-transformed UMI count plots for spatial flag, and demultiplexing and mapping statistics for read flag.
#' @param config Path to the YAML configuration file.
#' @param matched.data A data frame containing spatial transcriptomics data, including UMI counts and spatial coordinates. This is usually obtained from 'Run_loc_match' function.
#' @param Vis.spatial Logical value indicating whether to visualize spatial data. Defaults to TRUE.
#' @param Vis.read Logical value indicating whether to visualize read-level data. Defaults to TRUE.
#' @param show.config Logical value indicating whether to print the configuration. Defaults to TRUE.
#' @return A list contains spatial and read level visualization results.
#' @examples
#' temp_config <- tempfile(fileext = ".yml")
#' writeLines("technology_version: 'Visium 1.0'\noutput_directory: '.'", temp_config)
#' matched.data <- data.frame(
#' X_coordinate = runif(10, 0, 100),
#' Y_coordinate = runif(10, 0, 100),
#' UMI_count = sample(seq_len(100), 10),
#' spatial_name = paste0("Spot", seq_len(10)),
#' stringsAsFactors = FALSE
#' )
#' vis_results <- Run_Visualization(
#'   matched.data = matched.data,
#'   config = temp_config,
#'   Vis.spatial = TRUE,
#'   Vis.read = FALSE,
#'   show.config = FALSE
#' )
#' @export
#' @importFrom ggplot2 ggplot scale_fill_brewer aes geom_bar geom_text theme_minimal theme labs element_text geom_point scale_color_gradient element_blank element_rect xlim ylim
#' @importFrom stats reorder

if (getRversion() >= "2.15.1") {
  utils::globalVariables(
    c("UMI_count", "status", "count", "percentage"),
    package = "stPipe"
  )
}

Run_Visualization <- function(matched.data = NULL, config, Vis.spatial = TRUE, Vis.read = TRUE, show.config = TRUE) {

  config <- yaml::read_yaml(config)
  if (show.config) {
    message(config)
  }
  technology_version <- as.character(config$technology_version)
  output_dir <- as.character(config$output_directory)

  # Visualization of spatial data
  if (Vis.spatial && !is.null(matched.data)) {
    # adjust coordination system for Visium
    if (grepl("Visium", technology_version)) {
      matched.data$Y_coordinate <- -matched.data$Y_coordinate
    }

    # Set plotting limits
    x_range <- range(matched.data$X_coordinate)
    y_range <- range(matched.data$Y_coordinate)
    umi_range <- range(matched.data$UMI_count)

    # Raw UMI count plot
    raw_umi_plot <- ggplot(matched.data, aes(x = X_coordinate, y = Y_coordinate, color = UMI_count)) +
      geom_point(size = 3) +
      scale_color_gradient(low = "white", high = "red") +
      labs(title = 'Spatial Heatmap of UMI Count [raw]', x = 'X Coordinate', y = 'Y Coordinate', color = 'UMI Count') +
      theme_minimal(base_size = 15) +
      theme(
        plot.title = element_text(hjust = 0.5),
        panel.background = element_rect(fill = "gray"),
        plot.background = element_rect(fill = "gray"),
        axis.text = element_blank(),
        axis.title = element_blank()
      )

    # Apply plotting limits if available
    if (!is.null(x_range)) raw_umi_plot <- raw_umi_plot + xlim(x_range)
    if (!is.null(y_range)) raw_umi_plot <- raw_umi_plot + ylim(y_range)

    # Log-transformed UMI count plot
    log_umi_plot <- ggplot(matched.data, aes(x = X_coordinate, y = Y_coordinate, color = log(UMI_count))) +
      geom_point(size = 3) +
      scale_color_gradient(low = "white", high = "red") +
      labs(title = 'Spatial Heatmap of UMI Count [log]', x = 'X Coordinate', y = 'Y Coordinate', color = 'UMI Count [log]') +
      theme_minimal(base_size = 15) +
      theme(
        plot.title = element_text(hjust = 0.5),
        panel.background = element_rect(fill = "gray"),
        plot.background = element_rect(fill = "gray"),
        axis.text = element_blank(),
        axis.title = element_blank()
      )

    # Apply plotting limits if available
    if (!is.null(x_range)) log_umi_plot <- log_umi_plot + xlim(x_range)
    if (!is.null(y_range)) log_umi_plot <- log_umi_plot + ylim(y_range)
  }

  # Visualization of read-level data
  if (Vis.read) {
    # Read in data from the working directory
    sce <- scPipe::create_sce_by_dir(output_dir)
    sce <- scPipe::calculate_QC_metrics(sce)

    # Demultiplexing plot
    demultiplex_info <- scPipe::demultiplex_info(sce)[seq_len(6), ]
    demultiplex_info$count <- as.numeric(demultiplex_info$count)
    total_count <- sum(demultiplex_info$count)
    demultiplex_info$percentage <- (demultiplex_info$count / total_count) * 100

    demultiplex_plot <- ggplot(demultiplex_info, aes(x = reorder(status, -count), y = count, fill = status)) +
      geom_bar(stat = "identity") +
      geom_text(aes(label = paste0(round(percentage, 2), "%")), vjust = -0.5, size = 4) +
      scale_fill_brewer(palette = "Set3") +
      labs(title = "Barcode Demultiplexing Information", x = "Status", y = "Percentage") +
      theme_minimal(base_size = 15) +
      theme(
        plot.title = element_text(hjust = 0.5, size = 20, face = "bold"),
        axis.text.x = element_text(angle = 45, hjust = 1, size = 12),
        axis.text.y = element_text(size = 12),
        axis.title.x = element_text(size = 15, face = "bold"),
        axis.title.y = element_text(size = 15, face = "bold"),
        legend.position = "none"
      )

    # UMI duplication rate plot
    duplication_plot <- scPipe::plot_UMI_dup(sce)

    # Mapping statistics plot
    mapping_plot <- scPipe::plot_mapping(sce, percentage = TRUE, dataname = "sample data")
  }

  return(list(
    raw_UMI_plot = if (exists("raw_umi_plot")) raw_umi_plot else NULL,
    log_UMI_plot = if (exists("log_umi_plot")) log_umi_plot else NULL,
    demultiplex_plot = if (exists("demultiplex_plot")) demultiplex_plot else NULL,
    duplication_plot = if (exists("duplication_plot")) duplication_plot else NULL,
    mapping_plot = if (exists("mapping_plot")) mapping_plot else NULL
  ))
}

# Helper: minimal matched.data
make_matched_data <- function(n = 20, seed = 123) {
  set.seed(seed)
  data.frame(
    X_coordinate = runif(n, 0, 100),
    Y_coordinate = runif(n, 0, 100),
    UMI_count    = sample(1:50, n, replace = TRUE),
    spatial_name = paste0("Spot", seq_len(n)),
    stringsAsFactors = FALSE
  )
}

# Test spatial-only visualization
test_that("Run_Visualization returns raw and log UMI ggplot objects when Vis.spatial=TRUE and Vis.read=FALSE", {
  matched <- make_matched_data(30)
  tmp_dir <- tempfile("vis_spatial")
  dir.create(tmp_dir)
  cfg <- list(
    technology_version = "Visium 1.0",
    output_directory   = tmp_dir
  )
  cfg_file <- tempfile(fileext = ".yml")
  yaml::write_yaml(cfg, cfg_file)

  res <- Run_Visualization(
    matched.data = matched,
    config       = cfg_file,
    Vis.spatial  = TRUE,
    Vis.read     = FALSE,
    show.config  = FALSE
  )

  expect_type(res, "list")
  expect_named(res, c("raw_UMI_plot", "log_UMI_plot", "demultiplex_plot", "duplication_plot", "mapping_plot"))

  # raw and log plots are ggplot objects
  expect_s3_class(res$raw_UMI_plot, "ggplot")
  expect_s3_class(res$log_UMI_plot, "ggplot")

  # read-level plots should be NULL
  expect_null(res$demultiplex_plot)
  expect_null(res$duplication_plot)
  expect_null(res$mapping_plot)
})

# Test no visualization when both flags FALSE
test_that("Run_Visualization returns all NULL when Vis.spatial=FALSE and Vis.read=FALSE", {
  matched <- make_matched_data(15)
  tmp_dir <- tempfile("vis_none")
  dir.create(tmp_dir)
  cfg <- list(
    technology_version = "Visium 2.0",
    output_directory   = tmp_dir
  )
  cfg_file <- tempfile(fileext = ".yml")
  yaml::write_yaml(cfg, cfg_file)

  res <- Run_Visualization(
    matched.data = matched,
    config       = cfg_file,
    Vis.spatial  = FALSE,
    Vis.read     = FALSE,
    show.config  = FALSE
  )

  expect_true(all(vapply(res, is.null, logical(1))))
})

#####################################################
# Perform data clustering
#####################################################

#' @name Run_Clustering
#' @title Perform Basic Clustering Algorithms
#' @description This function performs basic clustering using t-SNE and UMAP, either before or after the QC step and outputs visualizations results.
#'
#' @details
#' T-SNE (t-Distributed Stochastic Neighbor Embedding)
#'
#' T-SNE is a popular dimensionality reduction technique used to project high-dimensional data into two or three dimensions.
#' It optimizes for preserving the local structure of the data, meaning that points that are close to each other in high-dimensional space will remain close in the lower-dimensional representation.
#' This method is widely used in single-cell RNA-seq and spatial transcriptomics to explore the heterogeneity of the data and identify cells or spatial regions with similar expression profiles.
#'
#' UMAP (Uniform Manifold Approximation and Projection)
#'
#' UMAP is another popular dimensionality reduction technique that aims to preserve both the local and global structures of the data, with a stronger emphasis on efficiency.
#' It excels at handling large datasets, generating low-dimensional projections in less time compared to T-SNE.
#' Unlike T-SNE, UMAP seeks to retain both local and global data structures, making it more suitable for capturing broad clustering patterns across the datasets.
#' @param gene.count A data frame containing gene count data with gene IDs as row names.
#' @param matched.data A data frame containing matched spatial coordinates with raw UMI counts.
#' @param num_clusters Number of clusters during clustering. Default set to five.
#' @return A list which contains interactive clustering visualization result with related data frames.
#' @examples
#' set.seed(123)
#' gene.count <- matrix(sample(0:100, 200 * 100, replace = TRUE), nrow = 200)
#' rownames(gene.count) <- paste0("Gene", seq_len(200))
#' colnames(gene.count) <- paste0("Spot", seq_len(100))
#' matched.data <- data.frame(
#'   spatial_name = paste0("Spot", seq_len(100)),
#'   x_coord = runif(100, 0, 10),
#'   y_coord = runif(100, 0, 10)
#' )
#' result <- Run_Clustering(
#'   gene.count = gene.count,
#'   matched.data = matched.data,
#'   num_clusters = 3
#' )
#' @export
#' @importFrom ggplot2 ggplot scale_fill_brewer aes geom_bar geom_text theme_minimal theme labs ggsave element_text geom_point scale_color_gradient element_blank element_rect xlim ylim scale_color_brewer

if (getRversion() >= "2.15.1") {
  utils::globalVariables(
    c("TSNE1","TSNE2","UMAP1","UMAP2","cluster")
  )
}

Run_Clustering <- function(gene.count, matched.data, num_clusters = 5) {

  gene_count_t <- t(gene.count)
  # Remove duplicates before running t-SNE and UMAP
  gene_count_t <- unique(gene_count_t)

  # UMAP & t-SNE
  umap_results <- umap::umap(gene_count_t)
  tsne_result <- Rtsne::Rtsne(gene_count_t, dims = 2, perplexity = 30, verbose = TRUE, max_iter = 1000, partial_pca = TRUE)

  # Create data frames for UMAP and t-SNE results
  umap_df <- data.frame(
    UMAP1 = umap_results$layout[, 1],
    UMAP2 = umap_results$layout[, 2],
    spot = rownames(gene_count_t)
  )

  tsne_df <- data.frame(
    TSNE1 = tsne_result$Y[, 1],
    TSNE2 = tsne_result$Y[, 2],
    spot = rownames(gene_count_t)
  )

  # K-means clustering on UMAP results
  kmeans_result_umap <- stats::kmeans(umap_results$layout, centers = 5)
  kmeans_result_tsne <- stats::kmeans(tsne_result$Y, centers = 5)

  # Assign cluster to UMAP and t-SNE data frames
  umap_df$cluster <- as.factor(kmeans_result_umap$cluster)
  tsne_df$cluster <- as.factor(kmeans_result_tsne$cluster)  # apply clustering results to t-SNE

  # Merge UMAP and t-SNE results with matched data
  merged_data_umap <- merge(umap_df, matched.data, by.x = "spot", by.y = "spatial_name", all.x = TRUE)
  merged_data_tsne <- merge(tsne_df, matched.data, by.x = "spot", by.y = "spatial_name", all.x = TRUE)

  # Generate and save the t-SNE & UMAP plot with cluster labels
  tsne_plot <- ggplot(merged_data_tsne, aes(x = -TSNE1, y = TSNE2, color = cluster)) +
    geom_point(size = 0.5) +
    scale_color_brewer(palette = "Set1") +  # color for different clusters
    labs(title = 't-SNE Plot of Clusters', x = 't-SNE1', y = 't-SNE2', color = 'Cluster') +
    theme_minimal(base_size = 15) +
    theme(
      panel.background = element_rect(fill = "white"),
      plot.background = element_rect(fill = "white"),
      plot.title = element_text(hjust = 0.5)
    )

  umap_plot <- ggplot(merged_data_umap, aes(x = UMAP1, y = UMAP2, color = cluster)) +
    geom_point(size = 0.5) +
    scale_color_brewer(palette = "Set1") +  # color for different clusters
    labs(title = 'UMAP Plot of Clusters', x = 'UMAP1', y = 'UMAP2', color = 'Cluster') +
    theme_minimal(base_size = 15) +
    theme(
      panel.background = element_rect(fill = "white"),
      plot.background = element_rect(fill = "white"),
      plot.title = element_text(hjust = 0.5)
    )

  # interactive plot
  tsne_interactive <- plotly::ggplotly(tsne_plot)
  umap_interactive <- plotly::ggplotly(umap_plot)

  # return data frames and plots for TSNE and UMAP
  return(list(tsne_df = tsne_df, tsne_plot = tsne_plot, umap_df = umap_df, umap_plot = umap_plot, tsne_interactive = tsne_interactive, umap_interactive = umap_interactive))
}

test_that("Run_Clustering returns correct structure on small example", {
  
  # 1) create a tiny gene.count: 6 genes × 4 spots
  gene.count <- matrix(sample(0:100, 200 * 100, replace = TRUE), nrow = 200)
  rownames(gene.count) <- paste0("Gene", seq_len(200))
  colnames(gene.count) <- paste0("Spot", seq_len(100))
  
  # 2) matched.data must have spatial_name matching colnames(gene.count)
  matched.data <- data.frame(
     spatial_name = paste0("Spot", seq_len(100)),
     x_coord = runif(100, 0, 10),
     y_coord = runif(100, 0, 10)
  )
  
  # 3) run the function
  out <- Run_Clustering(
    gene.count    = gene.count,
    matched.data  = matched.data,
    num_clusters  = 3
  )
  
  # 4) check it returns a list with named elements
  expect_type(out, "list")
  expected_names <- c("tsne_df", "tsne_plot", "umap_df", "umap_plot",
                      "tsne_interactive", "umap_interactive")
  expect_named(out, expected_names, ignore.order = TRUE)
  
  # 5) check tsne_df and umap_df are data.frames with correct columns
  expect_s3_class(out$tsne_df, "data.frame")
  expect_true(all(c("TSNE1", "TSNE2", "spot", "cluster") %in% colnames(out$tsne_df)))
  expect_equal(nrow(out$tsne_df), length(unique(rownames(unique(t(gene.count))))))
  
  expect_s3_class(out$umap_df, "data.frame")
  expect_true(all(c("UMAP1", "UMAP2", "spot", "cluster") %in% colnames(out$umap_df)))
  expect_equal(nrow(out$umap_df), nrow(unique(t(gene.count))))
  
  # 6) check clusters are factors and have appropriate levels
  expect_s3_class(out$tsne_df$cluster, "factor")
  expect_s3_class(out$umap_df$cluster, "factor")
  
  # 7) check plots are ggplot objects
  expect_s3_class(out$tsne_plot, "gg")
  expect_s3_class(out$umap_plot, "gg")
  
})

#####################################################
# Pre-processing sST data
#####################################################

#' @name Run_ST
#' @title Pre-processing function for sequencing-based spatial transcriptomics
#'
#' @description Pre-processing from FASTQ files to gene count matrix and extract spatial location information,
#' processing multiple sample is done via parallel computing. NB: for multiple samples, 'species' and 'technology_version' should be the same.
#' This function processes sequencing-based spatial transcriptomics data using various steps, including BAM to FASTQ conversion, trimming, index building, alignment, and barcode detection.
#' For Slideseq technology, the input should be BAM file and for all other technologies the input should be FASTQ file.
#' @examples
#' data_path <- system.file("extdata", package = "stPipe")
#' output_directory <- file.path(tempdir(), "stPipe_output")
#' config_list <- list(
#' data_directory = data_path,          
#' output_directory = output_directory, 
#' technology_version = "Visium_probe_v1",       
#' species = "mouse",                   
#' scpipe_nthreads = 4,                
#' max_reads = 100000,                  
#' min_count = 10,                      
#' number_of_locations = 100,          
#' bs1= -1,     
#' bl1= 0,     
#' bs2= 0,      
#' bl2= 16,     
#' us= 16,      
#' ul= 12,      
#' ll= 0      
#' )
#' config_file <- tempfile(fileext = ".yml")
#' yaml::write_yaml(config_list, config_file)
#' Run_ST(
#'   config = config_file, 
#'   show.config = FALSE
#' )
#' @param config Path to the YAML configuration file.
#' @param show.config Logical value indicating whether to print the configuration. Defaults to TRUE.
#' @return None. Outputs are saved to specified directories.
#' @importFrom Rcpp evalCpp
#' @export

Run_ST <- function(config, show.config = TRUE) {

  config <- yaml::read_yaml(config)
  if (show.config) {
    message(config)
  }

  data_dirs <- strsplit(as.character(config$data_directory), ",\\s*")[[1]]  # Multiple data directories
  out_dirs <- strsplit(as.character(config$output_directory), ",\\s*")[[1]]  # Multiple output directories

  if (length(data_dirs) != length(out_dirs)) {
    stop("The number of data directories and output directories must match!")
  }

  # Parallel processing with progress bar
  pbmcapply::pbmclapply(seq_along(data_dirs), function(i) {
    data_dir <- data_dirs[i]
    out_dir <- out_dirs[i]

    # Create the output directory and set the working directory
    dir.create(out_dir, showWarnings = FALSE)

    technology_version <- as.character(config$technology_version)
    species <- as.character(config$species)
    analysis <- as.character(config$analysis_source)
    index_fa <- as.character(config$index_fa)
    gff3 <- as.character(config$index_gff3)
    scpipe_nthreads <- as.numeric(config$scpipe_nthreads)
    max_reads <- as.numeric(config$max_reads)
    min_count <- as.numeric(config$min_count)
    number_of_locations <- as.numeric(config$number_of_locations)

    # FASTQ read structure design
    read_structure <- list(
      bs1 = config$bs1,
      bl1 = config$bl1,
      bs2 = config$bs2,
      bl2 = config$bl2,
      us = config$us,
      ul = config$ul
    )

    # Python script for BAM to FASTQ conversion
    py_reformat <- "
    import sys
    import pysam
    import os

    def process_bam_to_fastq(input_bam, output_fastq):
        with pysam.AlignmentFile(input_bam, 'rb') as bam_in, pysam.AlignmentFile('temp.bam', 'wb', template=bam_in) as bam_out:
            for read in bam_in:
                barcode = read.get_tag('XC')
                umi = read.get_tag('XM')
                new_read_name = f'{barcode}_{umi}#{read.query_name}'
                read.query_name = new_read_name
                bam_out.write(read)
        with pysam.AlignmentFile('temp.bam', 'rb') as bam_file, open(output_fastq, 'w') as fastq_file:
            for read in bam_file:
                read_name = read.query_name
                sequence = read.query_sequence
                quality = pysam.array_to_qualitystring(read.query_qualities)
                fastq_file.write(f'@{read_name}\\n{sequence}\\n+\\n{quality}\\n')

    input_bam = r.input_bam
    output_fastq = './trimmed.fastq'
    process_bam_to_fastq(input_bam, output_fastq)
    "

    # Process based on the technology version
    if (technology_version == "Slideseq") {

      input_bam <- as.character(list.files(data_dir, pattern = ".*\\.bam$", full.names = TRUE))
      message("Using the following BAM file:")
      message(input_bam)
      reticulate::py_run_string(py_reformat)
      combined_fastq <- file.path

    } else if (technology_version == "Stereoseq") {
      message("Using the following FASTQ files:")

      read_1_fq_path <- list.files(data_dir, pattern = "R1", full.names = TRUE)[1]
      read_2_fq_path <- list.files(data_dir, pattern = "R2", full.names = TRUE)[1]
      message(read_1_fq_path)
      message(read_2_fq_path)

      if (is.null(read_1_fq_path) || is.null(read_2_fq_path)) {
        stop("R1 or R2 FASTQ files not found!")
      }

      output_fq_path <- file.path(out_dir, "demultiplexed.fq.gz")
      h5_mapping_path <- as.character(config$h5_mapping_path)
      bin_size <- as.numeric(config$bin_size)
      n_reads <- max_reads
      coord_bc_start <- config$bs2
      coord_bc_len <- config$bl2
      umi_start <- config$us
      umi_len <- config$ul

      # use Rcpp function RunDemultiplex
      RunDemultiplex(
        read_1_fq_path = read_1_fq_path,
        read_2_fq_path = read_2_fq_path,
        h5_mapping_path = h5_mapping_path,
        output_fq_path = output_fq_path,
        n_reads = n_reads,
        coord_bc_start = coord_bc_start,
        coord_bc_len = coord_bc_len,
        umi_start = umi_start,
        umi_len = umi_len,
        bin_size = bin_size
      )

      combined_fastq_gz <- file.path(out_dir, "demultiplexed.fq.gz")
      combined_fastq <- file.path(out_dir, "demultiplexed.fq")

      if (file.exists(combined_fastq_gz)) {
        system(paste("gunzip -c", shQuote(combined_fastq_gz), ">", shQuote(combined_fastq)))
        message("Decompression completed: .fq.gz converted to .fq")
      } else {
        stop("Error: .fq.gz file not found at the specified location")
      }

    } else if (grepl("Visium", technology_version)) {

      message("Using the following FASTQ files:")
      fq_R2_files <- list.files(data_dir, pattern = "R1", full.names = TRUE)
      message(fq_R2_files)
      fq_R1_files <- list.files(data_dir, pattern = "R2", full.names = TRUE)
      message(fq_R1_files)
      if (length(fq_R1_files) != 1 || length(fq_R2_files) != 1) {
        stop("Expected exactly one R1 and one R2 FASTQ file, but found inconsistencies")
      }
      combined_fastq <- file.path(out_dir, "trimmed.fastq")
      scPipe::sc_trim_barcode(
        outfq = combined_fastq,
        r1 = fq_R1_files[1],
        r2 = fq_R2_files[1],
        read_structure = read_structure
      )
    }

    aligned_bam <- file.path(out_dir, "aligned.bam")
    mapped_bam <- file.path(out_dir, "aligned.mapped.bam")

    # for probe-based technologies
    if (grepl("probe", technology_version)) {

      if (technology_version == "Visium_probe_v1" && species == "human") {
        csv_file <- readRDS(system.file("extdata", "Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A.rds", package = "stPipe"))
      } else if (technology_version == "Visium_probe_v2" && species == "human") {
        csv_file <- readRDS(system.file("extdata", "Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A.rds", package = "stPipe"))
      } else if (technology_version == "Visium_probe_v1" && species == "mouse") {
        csv_file <- readRDS(system.file("extdata", "Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A.rds", package = "stPipe"))
      } else {
        stop("Unsupported combination of technology_version and species for probe-based Visium")
      }

      # Generate FASTA and GFF3 files based on the probe set
      generate_fasta <- function(gene_id, probe_seq) {
        return(paste0(">", gene_id, "\n", probe_seq))
      }
      remove_duplicates <- function(csv_file) {
        unique_data <- csv_file[!duplicated(csv_file[[1]]), ]
        return(unique_data)
      }
      generate_gff3 <- function(csv_file, output_file) {
        unique_rows <- remove_duplicates(csv_file)
        file_conn <- file(output_file, "w")
        writeLines("##gff-version 3", file_conn)
        for (i in seq_len(nrow(unique_rows))) {
          gene_id <- unique_rows[i, 1]
          gff3_line <- paste(gene_id, ".", "exon", "1", "100000000", ".", "+", ".", paste0("gene_id=", gene_id), sep = "\t")
          writeLines(gff3_line, file_conn)
        }
        close(file_conn)
        message("GFF3 file generated based on the provided probe set:", output_file, "\n")
      }

      fasta_file <- file.path(out_dir, "probe_set.fa")
      gff3_file <- file.path(out_dir, "probe_set.gff3")

      unique_rows <- remove_duplicates(csv_file)
      fasta_content <- ""
      for (i in seq_len(nrow(unique_rows))) {
        gene_id <- unique_rows[i, 1]
        probe_seq <- unique_rows[i, 2]
        fasta_content <- paste0(fasta_content, generate_fasta(gene_id, probe_seq), "\n")
      }
      fasta_content <- sub("\n$", "", fasta_content)
      write(fasta_content, file = fasta_file)
      message("FASTA file generated based on the provided probe set:", fasta_file, "\n")

      generate_gff3(csv_file, gff3_file)

      Rsubread::buildindex(
        out_dir,
        reference = fasta_file
      )
      index_path <- out_dir
      exon_anno <- gff3_file
    } else {
      # For non-probe-based technologies (polyA-based), use the provided GFF3 and FASTA files
      Rsubread::buildindex(
        out_dir,
        reference = index_fa
      )
      index_path <- out_dir
      exon_anno <- gff3
    }

    # Alignment via Rsubread
    Rsubread::align(
      index = index_path,
      readfile1 = combined_fastq,
      output_file = file.path(out_dir, "out.aln.bam"),
      nthreads = scpipe_nthreads
    )

    # Mapping and counting
    barcode_anno <- "sample_index.csv"
    scPipe::sc_exon_mapping(
      file.path(out_dir, "out.aln.bam"),
      file.path(out_dir, "out.map.bam"),
      exon_anno,
      nthreads = scpipe_nthreads
    )
    scPipe::sc_detect_bc(
      infq = combined_fastq,
      outcsv = file.path(out_dir, barcode_anno),
      bc_len = read_structure$bl2,
      max_reads = max_reads,
      min_count = min_count,
      number_of_cells = number_of_locations
    )
    scPipe::sc_count_aligned_bam(
      inbam = file.path(out_dir, "out.aln.bam"),
      outbam = mapped_bam,
      annofn = exon_anno,
      bc_len = read_structure$bl2,
      UMI_len = read_structure$ul,
      outdir = out_dir,
      bc_anno = file.path(out_dir, barcode_anno)
    )

  }, mc.cores = length(data_dirs))  # Number of cores based on data directories
}

# Helper: write a minimal config yaml
write_config <- function(cfg_list) {
  cfg_file <- tempfile(fileext = ".yml")
  yaml::write_yaml(cfg_list, cfg_file)
  cfg_file
}

# Test that mismatched data and output directories throw an error
test_that("Run_ST stops when data and output dirs count mismatch", {
  cfg_list <- list(
    data_directory    = "dir1,dir2",
    output_directory  = "out1",
    technology_version= "Visium_probe_v1",
    species           = "mouse",
    analysis_source   = "",
    index_fa          = "",
    index_gff3        = "",
    scpipe_nthreads   = 1,
    max_reads         = 10,
    min_count         = 1,
    number_of_locations = 5,
    bs1 = -1, bl1 = 0, bs2 = 0, bl2 = 16, us = 16, ul = 12
  )
  cfg_file <- write_config(cfg_list)
  expect_error(
    Run_ST(config = cfg_file, show.config = FALSE),
    "The number of data directories and output directories must match!"
  )
})

# Visium inconsistency: more/less R1 or R2 files
test_that("Run_ST Visium stops when multiple or missing FASTQ files", {
  tmp_data <- tempfile("data")
  tmp_out  <- tempfile("out")
  dir.create(tmp_data); dir.create(tmp_out)
  # create two R1 and one R2
  file.create(file.path(tmp_data, "sample_R1_1.fastq"))
  file.create(file.path(tmp_data, "sample_R1_2.fastq"))
  file.create(file.path(tmp_data, "sample_R2.fastq"))
  cfg <- list(
    data_directory    = tmp_data,
    output_directory  = tmp_out,
    technology_version= "Visium_v1",
    species           = "mouse",
    analysis_source   = "",
    index_fa          = "",
    index_gff3        = "",
    scpipe_nthreads   = 1,
    max_reads         = 10,
    min_count         = 1,
    number_of_locations = 5,
    bs1 = -1, bl1 = 0, bs2 = 0, bl2 = 16, us = 16, ul = 12
  )
  cfg_file <- write_config(cfg)
  expect_error(
    Run_ST(config = cfg_file, show.config = FALSE),
    "Expected exactly one R1 and one R2 FASTQ file, but found inconsistencies"
  )
})

# Unsupported combination of technology_version and species in probe-based Visium
test_that("Run_ST stops on unsupported probe-based Visium combination", {
  tmp_data <- tempfile("data")
  tmp_out  <- tempfile("out")
  dir.create(tmp_data); dir.create(tmp_out)
  # create one R1 and one R2 to pass earlier checks
  file.create(file.path(tmp_data, "sample_R1.fastq"))
  file.create(file.path(tmp_data, "sample_R2.fastq"))
  cfg <- list(
    data_directory    = tmp_data,
    output_directory  = tmp_out,
    technology_version= "Visium_probe_v2", # v2 & mouse unsupported
    species           = "mouse",
    analysis_source   = "",
    index_fa          = "",
    index_gff3        = "",
    scpipe_nthreads   = 1,
    max_reads         = 10,
    min_count         = 1,
    number_of_locations = 5,
    bs1 = -1, bl1 = 0, bs2 = 0, bl2 = 16, us = 16, ul = 12
  )
  cfg_file <- write_config(cfg)
  expect_error(
    Run_ST(config = cfg_file, show.config = FALSE),
    "Unsupported combination of technology_version and species for probe-based Visium"
  )
})

#####################################################
# Generate downstream objects for mainstream tools for further analysis
#####################################################

#' @name Run_Create_Obj
#' @title This function creates specified spatial transcriptomics data object for further personalized downstream analysis
#' @details Current mainstream analytic tools for downstream includes: Seurat, SpatialExperiment supported tools, and Squidpy.
#' This function can help creates corresponding objects for further downstream analysis.
#'
#' @param gene.matrix Gene count matrix. This is usually obtained from 'Run_ST' function.
#' @param matched.data Data frame which contains spatial localization matched with gene count matrix. This is usually obtained from 'Run_loc_match' function.
#' @param obj.type Type of spatial transcriptomics object being created, can be 'Seurat', 'SpatialExperiment', or 'AnnData'.
#' @param ss.radius Optional. Radius for filtering SlideSeq or Curio-seeker spots for Seurat object. Default is 3000.
#' @param tech Type of spatial transcriptomics sequencing technology, can be "Visium", "Slideseq", "Curio-seeker", or "Stereoseq".
#' @return Created spatial transcriptomics data object as required by 'obj.type'.
#' @examples
#' set.seed(123)
#' gene.count <- matrix(sample(0:100, 200*100, TRUE), nrow=200)
#' rownames(gene.count) <- paste0('Gene', 1:200)
#' colnames(gene.count) <- paste0('Spot', 1:100)
#' matched.data <- data.frame(
#'   spatial_name = colnames(gene.count),
#'   barcode_sequence = paste0('BC', 1:100),
#'   X_coordinate = runif(100,0,10),
#'   Y_coordinate = runif(100,0,10),
#'   UMI_count = sample(50:200,100,TRUE)
#' )
#' seu <- Run_Create_Obj(
#'   gene.matrix = gene.count,
#'   matched.data = matched.data,
#'   obj.type = 'Seurat',
#'   tech = 'Slideseq'
#' )
#' @export
#' @importFrom ggplot2 theme
#' @importFrom methods new
#' @importFrom SummarizedExperiment rowData<-

Run_Create_Obj <- function(gene.matrix, matched.data, obj.type, tech, ss.radius = 3000) {

  if (!all(matched.data$spatial_name %in% colnames(gene.matrix))) {
    stop("Spatial locations in matched.data do not match column names of gene.matrix!")
  }

  counts_mat <- as.matrix(gene.matrix)
  matched.data <- matched.data[match(colnames(counts_mat), matched.data$spatial_name), ]
  meta_df <- data.frame(
    X   = matched.data$X_coordinate,
    Y   = matched.data$Y_coordinate,
    UMI = matched.data$UMI_count,
    row.names = matched.data$barcode_sequence
  )
  colnames(counts_mat) <- matched.data$barcode_sequence

  # Create Seurat object
  if (obj.type == "Seurat") {

    # Create a Seurat object
    obj <- SeuratObject::CreateSeuratObject(counts = counts_mat, meta.data = meta_df, assay = 'Spatial')
    coords <- meta_df[, c("X","Y"), drop = FALSE]

    obj[['image']] <- new(
      Class = 'SlideSeq',
      assay = "Spatial",
      coordinates = coords)

    # add spatial information to created Seurat object based on different technology
    if (tech == "Slideseq" | tech == "Curio-seeker"){

      # remove stray beads which fall outside the main Slideseq puck area
      obj <- Seurat::FilterSlideSeq(object = obj, radius = ss.radius, do.plot = TRUE)

    }
  } else if (obj.type == "SpatialExperiment") {

    obj <- SpatialExperiment::SpatialExperiment(
      assays = list(counts = counts_mat),
      colData = meta_df,
      spatialCoords = as.matrix(meta_df[, c('X','Y')])
    )
    rowData(obj)$gene_name <- rownames(gene.matrix)


  } else if (obj.type == "AnnData") {

    # Create an AnnData object
    anndata <- reticulate::import("anndata")
    obj <- anndata$AnnData(X = gene.matrix)
    obj$obs <- matched.data

    py_create_anndata <- "
    import anndata
    adata = anndata.AnnData(X = r.gene_matrix)
    adata.obs = r.matched_data
    "
    reticulate::py_run_string(py_create_anndata)

    obj <- reticulate::py$adata

  } else {

    stop("Unknown obj.type! Please choose class from 'Seurat', 'SpatialExperiment', or 'AnnData'.")
  }

  return(obj)

}

# Helper: generate dummy gene.matrix and matched.data
make_input <- function(n_genes = 50, n_spots = 30, seed = 42) {
  set.seed(seed)
  gene_ids <- paste0("Gene", seq_len(n_genes))
  spot_ids <- paste0("Spot", seq_len(n_spots))
  mat <- matrix(sample(0:100, n_genes * n_spots, replace = TRUE),
                nrow = n_genes, ncol = n_spots,
                dimnames = list(gene_ids, spot_ids))
  gene_matrix <- as.data.frame(mat)
  gene_matrix$gene_id <- rownames(gene_matrix)
  gene_matrix <- gene_matrix[, c("gene_id", spot_ids)]

  md <- data.frame(
    spatial_name     = spot_ids,
    barcode_sequence = paste0("BC", seq_len(n_spots)),
    X_coordinate     = runif(n_spots, 0, 100),
    Y_coordinate     = runif(n_spots, 0, 100),
    UMI_count        = sample(1:500, n_spots, replace = TRUE),
    stringsAsFactors = FALSE
  )
  list(gene_matrix = gene_matrix, matched_data = md)
}

# error when matched.data has unmatched spatial_name
test_that("Run_Create_Obj stops when spatial_name mismatch", {
  inp <- make_input()
  inp$matched_data$spatial_name[1] <- "WrongSpot"
  expect_error(
    Run_Create_Obj(
      gene.matrix   = inp$gene_matrix,
      matched.data  = inp$matched_data,
      obj.type      = "Seurat",
      tech          = "Visium"
    ),
    "Spatial locations in matched.data do not match column names of gene.matrix!"
  )
})

## ----summary, echo=FALSE------------------------------------------------------
table_data <- data.frame(
  Protocol = c("Visium", "Visium HD", "Slide-seq/Curio-seeker", "Stereo-seq", "Curio-seeker"),
  Resolution_micron = c(50, 2, 10, 10, 10),
  Spot_distance_micron = c(100, "0 (no gaps)", 10, 0.5, 10),
  Typical_array_size = c("0.65cm x 0.65cm / 1.1cm x 1.1cm", 
                         "0.65cm x 0.65cm / 1.1cm x 1.1cm", 
                         "/", 
                         "1cm x 1cm; (max: 13.2cm x 13.2cm)", 
                         "0.3cm x 0.3cm / 1cm x 1cm")
)

knitr::kable(table_data, format = "markdown", col.names = c("Protocol", "Resolution (micron)", "Spot distance (micron)", "Typical array size"))

## ----setup, message=FALSE-----------------------------------------------------
library(stPipe)
config <- system.file("config", "config_stPipe.yml", package = "stPipe")
yaml_content <- readLines(config)
cat(yaml_content, sep = "\n")

## ----input--------------------------------------------------------------------
# FASTQ file path:
data_directory <- file.path(tempdir(), "stPipe_demo_data")
if (!dir.exists(data_directory)) {
  dir.create(data_directory, recursive = TRUE)
}
options(timeout = 600)
R1_url <- "https://zenodo.org/records/14920583/files/stPipe_demo_R1.fq.gz?download=1"
R2_url <- "https://zenodo.org/records/14920583/files/stPipe_demo_R2.fq.gz?download=1"
R1_path <- file.path(data_directory, "stPipe_demo_R1.fq.gz")
R2_path <- file.path(data_directory, "stPipe_demo_R2.fq.gz")
download.file(R1_url, R1_path)
download.file(R2_url, R2_path)
config <- system.file("config", "config_stPipe.yml", package = "stPipe")
config <- yaml::read_yaml(config)
config$data_directory <- data_directory

## ----yaml, eval=TRUE----------------------------------------------------------
output_directory <- file.path(tempdir(), "stPipe_output")
if (!dir.exists(output_directory)) {
  dir.create(output_directory, recursive = TRUE)
}
config$output_directory <- output_directory
demo_config_path <- tempfile(fileext = ".yml")
yaml::write_yaml(config, demo_config_path)

## ----Run_ST,eval=TRUE---------------------------------------------------------
Run_ST(config = demo_config_path, show.config = FALSE)

## ----Run_Loc_Match, eval=TRUE-------------------------------------------------
st.result <- Run_Loc_Match(config = demo_config_path, pixel = FALSE, show.config = FALSE)
head(st.result$matched_data)

## ----qc, eval=TRUE------------------------------------------------------------
# adjust some parameter and update the config file
config$qc_per <- c("0.4_0.6")
yaml::write_yaml(config, demo_config_path)

## ----Run_QC, eval=TRUE, warning=FALSE-----------------------------------------
qc.results <- Run_QC(config = demo_config_path, matched.data = st.result$matched_data, gene.matrix = st.result$gene_count, show.config = FALSE)
dim(qc.results$filtered_spatial_coords)[1]/dim(st.result$matched_data)[1]

## ----Run_Clustering, eval=TRUE------------------------------------------------
output <- capture.output(
  Cluster.results <- Run_Clustering(
    gene.count = st.result$gene_count,
    matched.data = st.result$matched_data,
    num_clusters = 5
  )
)
cat(output[seq_along(1:15)], sep = "\n")

## ----Run_Interactive, eval=TRUE-----------------------------------------------
 Run_Interactive(
   matched_data = st.result$matched_data,
   clustering_result = Cluster.results$tsne_df,
   background_img = NULL,
   reduction_method = "tsne",
   point_size = 1
)

## ----Run_Visualization, eval=TRUE---------------------------------------------
Vis.results <- Run_Visualization(
  matched.data = st.result$matched_data,
  config = demo_config_path,
  Vis.spatial = TRUE,
  Vis.read = TRUE,
  show.config = FALSE
)

## ----demultiplex_plot, eval=TRUE, fig.height=7, fig.width=7-------------------
Vis.results$demultiplex_plot

## ----mapping_plot, eval=TRUE, fig.height=7, fig.width=7-----------------------
Vis.results$mapping_plot

## ----UMI_plot, echo=FALSE, fig.show='hold', fig.height=5, fig.width=5---------
Vis.results$raw_UMI_plot
Vis.results$log_UMI_plot

## ----seu_obj------------------------------------------------------------------
library(Seurat)
library(SeuratObject)
seu <- Run_Create_Obj(
   gene.matrix = st.result$gene_count,
   matched.data = st.result$matched_data,
   obj.type = 'Seurat',
   tech = 'Visium'
 )
seu

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#####################################################
# Perform personal selection of spatial domain
#####################################################

#' @name Run_Interactive
#' @title Interactive Visualization for Spatial Transcriptomics Data and spot plot with save functionality
#' @details This function generates interactive plots to visualize spatial transcriptomics data. It takes matched spatial coordinates and raw UMI counts to produce customized t-SNE or UMAP plots overlayed on a optional background H&E image.
#' @param matched_data A data frame containing matched spatial coordinates with raw UMI counts.
#' @param clustering_result A data frame containing matched spatial coordinates with raw UMI counts.
#' @param background_img Optional background H&E image.
#' @param reduction_method T-SNE ("tsne") or UMAP ("umap") result data frame obtained from 'Run_Clustering' function. Default set as "tsne".
#' @param point_size Size of point shown in the spatial heatmap. Default set as 1.
#' @examples
#' matched_data <- data.frame(
#' X_coordinate = runif(10, 0, 100),
#' Y_coordinate = runif(10, 0, 100),
#' UMI_count = sample(seq_len(100), 10),
#' spatial_name = paste0("Spot", seq_len(10)),
#' stringsAsFactors = FALSE
#' )
#' clustering_result <- data.frame(
#' TSNE1 = runif(10, -50, 50),
#' TSNE2 = runif(10, -50, 50),
#' spot = paste0("Spot", seq_len(10)),
#' cluster = sample(seq_len(3), 10, replace = TRUE),
#' stringsAsFactors = FALSE
#' )
#' if (interactive()) {
#' Run_Interactive(
#'   matched_data = matched_data,
#'   clustering_result = clustering_result,
#'   background_img = NULL,
#'   reduction_method = "tsne",
#'   point_size = 1)
#'                                }
#' @return R-shiny interactive webpage.
#' @export
#' @importFrom ggplot2 ggplot scale_fill_brewer aes geom_bar geom_text theme_minimal theme labs ggsave element_text geom_point scale_color_gradient element_blank element_rect xlim ylim scale_color_brewer
#' @importFrom shiny reactive

if (getRversion() >= "2.15.1") {
  utils::globalVariables(
    c("TSNE1", "TSNE2", "UMAP1", "UMAP2", "cluster",
      "X_coordinate", "Y_coordinate", "UMI_count",
      "spatial_name")
  )
}

Run_Interactive <- function(matched_data, clustering_result, background_img = NULL, reduction_method = "tsne", point_size = 1) {
  # Data pre-check
  required_cols_matched <- c("X_coordinate", "Y_coordinate", "UMI_count", "spatial_name")

  # Define required columns based on reduction_method
  if (reduction_method == "tsne") {
    required_cols_reduction <- c("TSNE1", "TSNE2", "spot", "cluster")
  } else if (reduction_method == "umap") {
    required_cols_reduction <- c("UMAP1", "UMAP2", "spot", "cluster")
  } else {
    stop("reduction_method must be either 'tsne' or 'umap'.")
  }

  # Check if required columns are present in matched_data
  if (!all(required_cols_matched %in% colnames(matched_data))) {
    stop(paste("matched_data must contain columns:", paste(required_cols_matched, collapse = ", ")))
  }

  # Check if required columns are present in clustering_result
  if (!all(required_cols_reduction %in% colnames(clustering_result))) {
    stop(paste("clustering_result must contain columns:", paste(required_cols_reduction, collapse = ", ")))
  }

  # Create UMI count spatial data frame
  plot_d <- matched_data %>%
    dplyr::select(X_coordinate, Y_coordinate, UMI_count, spatial_name)

  # Combine clustering_result with plot_d
  plot_d <- plot_d %>%
    dplyr::left_join(clustering_result, by = c("spatial_name" = "spot"))
  plot_d$cluster <- as.factor(plot_d$cluster)


  # Create a highlight key for interactivity
  key <- plotly::highlight_key(plot_d, ~spatial_name)

  # Plot left UMI count spatial plot
  if (!is.null(background_img)) {
    maxX <- dim(background_img)[1]
    maxY <- dim(background_img)[2]
    p1 <- ggplot2::ggplot(mapping = ggplot2::aes(seq_len(maxX), seq_len(maxY))) +
      ggplot2::annotation_raster(background_img, xmin = 1, xmax = maxX, ymin = 1, ymax = maxY)
  } else {
    maxX <- max(plot_d$X_coordinate)
    minX <- min(plot_d$X_coordinate)
    maxY <- max(plot_d$Y_coordinate)
    minY <- min(plot_d$Y_coordinate)
    p1 <- ggplot2::ggplot(mapping = ggplot2::aes(minX:maxX, minX:maxY))
  }

  p1 <- p1 +
    ggplot2::geom_point(
      data = key,
      ggplot2::aes(x = X_coordinate, y = maxY - Y_coordinate, colour = UMI_count, alpha = ifelse(is.null(background_img), 1, 0.85)),
      size = point_size
    ) +
    ggplot2::coord_fixed() +
    ggplot2::scale_color_viridis_c() +
    ggplot2::labs(color = "UMI Count") +
    ggplot2::theme_void()

  # Plot right UMAP or t-SNE plot
  if (reduction_method == "tsne") {
    p2 <- ggplot2::ggplot(key, ggplot2::aes(x = TSNE1, y = TSNE2, colour = as.factor(cluster))) +
      ggplot2::geom_point(size = 1) +
      ggplot2::scale_color_discrete(name = "Cluster") +
      ggplot2::labs(color = "Cluster") +
      ggplot2::theme_minimal()
  } else {
    p2 <- ggplot2::ggplot(key, ggplot2::aes(x = UMAP1, y = UMAP2, colour = as.factor(cluster))) +
      ggplot2::geom_point(size = 1) +
      ggplot2::scale_color_discrete(name = "Cluster") +
      ggplot2::labs(color = "Cluster") +
      ggplot2::theme_minimal()
  }

  # Convert plots to interactive
  p1 <- plotly::ggplotly(p1, source = "A") %>%
    plotly::highlight(on = "plotly_selected", off = "plotly_deselect") %>%
    plotly::config(
      toImageButtonOptions = list(
        format = "svg",
        filename = "UMI_Spatial_Plot",
        width = 800,
        height = 500
      )
    )

  p2 <- plotly::ggplotly(p2, source = "A") %>%
    plotly::highlight(on = "plotly_selected", off = "plotly_deselect") %>%
    plotly::config(
      toImageButtonOptions = list(
        format = "svg",
        filename = "Reduction_Plot",
        width = 800,
        height = 500
      )
    )

  # Create Shiny app for saving functionality
  shiny::shinyApp(
    ui = shiny::fluidPage(
      shiny::fluidRow(
        shiny::column(6, plotly::plotlyOutput("spatial_plot")),
        shiny::column(6, plotly::plotlyOutput("reduction_plot"))
      ),
      shiny::actionButton("add_selection", "Add Selection", icon = shiny::icon("plus")),
      shiny::actionButton("clear_last", "Clear Last Selection", icon = shiny::icon("eraser")),
      shiny::actionButton("reset", "Reset All Selections", icon = shiny::icon("refresh")),  # New reset button
      shiny::actionButton("save", "Save All Selected Regions of Interest (ROI)", icon = shiny::icon("save")),
      shiny::tableOutput("selected_data")
    ),
    server = function(input, output, session) {
      # Reactive expressions for generating the initial plots
      initial_spatial_plot <- reactive({
        plotly::ggplotly(p1, source = "A") %>%
          plotly::highlight(on = "plotly_selected", off = "plotly_deselect") %>%
          plotly::config(
            toImageButtonOptions = list(
              format = "svg",
              filename = "UMI_Spatial_Plot",
              width = 800,
              height = 500
            )
          )
      })

      initial_reduction_plot <- reactive({
        plotly::ggplotly(p2, source = "A") %>%
          plotly::highlight(on = "plotly_selected", off = "plotly_deselect") %>%
          plotly::config(
            toImageButtonOptions = list(
              format = "svg",
              filename = "Reduction_Plot",
              width = 800,
              height = 500
            )
          )
      })

      # Render the initial plots
      output$spatial_plot <- plotly::renderPlotly({ initial_spatial_plot() })
      output$reduction_plot <- plotly::renderPlotly({ initial_reduction_plot() })

      # Save selected subset in reactive list
      selected_regions <- shiny::reactiveValues(data = list())
      selected_spatials <- shiny::reactiveVal(character())

      # Add selection to the list
      shiny::observeEvent(input$add_selection, {
        selected_points <- plotly::event_data("plotly_selected", source = "A") # Get selected data
        if (!is.null(selected_points)) {
          selected_spatials(unique(c(selected_spatials(), selected_points$key))) # Update selected spatials
          selected_subset <- matched_data %>% dplyr::filter(spatial_name %in% selected_spatials()) # Use updated selected_spatials
          selected_regions$data <- list(selected_subset)
        }
      })

      # Clear the last selection
      shiny::observeEvent(input$clear_last, {
        if (length(selected_regions$data) > 0) {
          selected_regions$data <- list()
          selected_spatials(character()) # Clear selected spatials
        }
      })

      # Reset all selections and fully re-render the plots
      shiny::observeEvent(input$reset, {
        selected_regions$data <- list()
        selected_spatials(character())

        # Trigger re-rendering by reassigning the plots
        output$spatial_plot <- plotly::renderPlotly({ initial_spatial_plot() })
        output$reduction_plot <- plotly::renderPlotly({ initial_reduction_plot() })
      })

      # Display combined selected data
      output$selected_data <- shiny::renderTable({
        if (length(selected_regions$data) > 0) {
          combined_selected_data <- do.call(rbind, selected_regions$data)
          return(combined_selected_data)
        }
      })

      # Save all selected data
      shiny::observeEvent(input$save, {
        if (length(selected_regions$data) > 0) {
          combined_selected_data <- do.call(rbind, selected_regions$data)
          assign("selected_ROI", combined_selected_data, envir = .GlobalEnv)
          shiny::showNotification("All selected regions saved to global environment as 'selected_ROI'", type = "message")
        }
      })
    }
  )
}

#' Paired-End FASTQ Demo Files
#'
#' A pair of gzipped FASTQ files for demo (FFPE, probe-based mouse spleen sample).
#'
#' @docType data
#' @name demo_data
#' @aliases demo_R1.fq.gz demo_R2.fq.gz
#' @keywords datasets
#'
#' @usage demo_data
#'
#' @format A character vector of length 2:
#' \describe{
#'   \item{demo\_R1.fq.gz}{Read1 FASTQ file}
#'   \item{demo\_R2.fq.gz}{Read2 FASTQ file}
#' }
#'
#' @source
#' <https://zenodo.org/records/12788291>
NULL

demo_data <- function() {
  system.file(
    "extdata",
    c("demo_R1.fq.gz", "demo_R2.fq.gz"),
    package = "stPipe"
  )
}


#' Visium Spatial Barcode Coordinates (Versions 1–5)
#'
#' Five separate datasets containing spot barcodes and their
#' X/Y coordinates on the Visium capture area. Each object is
#' a data.frame with three columns which stand for: `barcode`, `x`, and `y`.
#'
#' @name visium_v1_coordinates
#' @aliases visium_v1_coordinates
#' @docType data
#' @title Visium v1 Spatial Barcode Coordinates
#'
#' @format A data.frame with 4992 rows (14336 rows for v5) and 3 columns:
#' \describe{
#'   \item{barcode}{Spot barcode (e.g., "AAACGCTGAAAGCGTC-1")}
#'   \item{x}{X-coordinate on the capture area}
#'   \item{y}{Y-coordinate on the capture area}
#' }
#'
#' @usage
#' visium_v1_coordinates
#'
#'
#' @source
#' 10x Genomics Support: Visium Spatial Barcode Inclusion List
#' (<https://kb.10xgenomics.com/hc/en-us/articles/360041426992-Where-can-I-find-the-Space-Ranger-barcode-inclusion-list-formerly-barcode-whitelist-and-their-coordinates-on-the-slide>)
NULL

visium_coordinates <- function(version = 1L) {
  ver <- match.arg(as.character(version), as.character(1:5))
  fname <- sprintf("visium-v%s_coordinates.rds", ver)
  path <- system.file("extdata", fname, package = "stPipe")
  if (nzchar(path)) {
    readRDS(path)
  } else {
    stop("Unsupported Visium version: ", version)
  }
}

visium_v1_coordinates <- function() {
  system.file("extdata", "visium_v1_coordinates.rds", package = "stPipe")
}

#' @rdname visium_v1_coordinates
#' @aliases visium_v2_coordinates
#' @title Visium v2 Spatial Barcode Coordinates
#'
#' @name visium_v2_coordinates
#' @docType data
NULL

#' @rdname visium_v1_coordinates
#' @aliases visium_v3_coordinates
#' @title Visium v3 Spatial Barcode Coordinates
#'
#' @name visium_v3_coordinates
#' @docType data
NULL

#' @rdname visium_v1_coordinates
#' @aliases visium_v4_coordinates
#' @title Visium v4 Spatial Barcode Coordinates
#'
#' @name visium_v4_coordinates
#' @docType data
NULL

#' @rdname visium_v1_coordinates
#' @aliases visium_v5_coordinates
#' @title Visium v5 Spatial Barcode Coordinates
#'
#' @name visium_v5_coordinates
#' @docType data
NULL

#' Probe set for Human Transcriptome v1
#'
#' @docType data
#' @name Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A
#' @aliases Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A.rds
#' @keywords datasets
#'
#' @usage Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A
#'
#' @format A data.frame with 18681 rows and 2 columns:
#' \describe{
#'   \item{gene_id}{Ensembl gene ID}
#'   \item{probe_seq}{Sequence for designed probe set}
#' }
#'
#' @source
#' <https://www.10xgenomics.com/support/software/space-ranger/downloads#probe-set-downloads>
NULL

Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A <- function() {
  system.file("extdata", "Visium_Human_Transcriptome_Probe_Set_v1_0_GRCh38_2020_A.rds", package = "stPipe")
}

#' Probe set for Human Transcriptome v2
#'
#' @docType data
#' @name Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A
#' @aliases Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A.rds
#' @keywords datasets
#'
#' @usage Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A
#'
#' @format A data.frame with 53504 rows and 2 columns:
#' \describe{
#'   \item{gene_id}{Ensembl gene ID}
#'   \item{probe_seq}{Sequence for designed probe set}
#' }
#'
#' @source
#' <https://www.10xgenomics.com/support/software/space-ranger/downloads#probe-set-downloads>
NULL

Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A <- function() {
  system.file("extdata", "Visium_Human_Transcriptome_Probe_Set_v2_0_GRCh38_2020_A.rds", package = "stPipe")
}

#' Probe set for Mouse Transcriptome v1
#'
#' @docType data
#' @name Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A
#' @aliases Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A.rds
#' @keywords datasets
#'
#' @usage Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A
#'
#' @format A data.frame with 20057 rows and 2 columns:
#' \describe{
#'   \item{gene_id}{Ensembl gene ID}
#'   \item{probe_seq}{Sequence for designed probe set}
#' }
#'
#' @source
#' <https://www.10xgenomics.com/support/software/space-ranger/downloads#probe-set-downloads>
NULL

Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A <- function() {
  system.file("extdata", "Visium_Mouse_Transcriptome_Probe_Set_v1_0_mm10_2020_A.rds", package = "stPipe")
}

#' H&E Image for mouse olfactory bulb
#'
#' @docType data
#' @name tissue_hires_image
#' @aliases tissue_hires_image.png
#' @keywords datasets
#'
#' @usage tissue_hires_image
#'
#' @format A high-resolution image file
#'
#' @source
#' <https://github.com/ucagenomix/SiT>
NULL

tissue_hires_image <- function() {
  system.file("extdata", "tissue_hires_image.png", package = "stPipe")
}


#' Coordinates for mouse olfactory bulb H&E Image
#'
#' @docType data
#' @name ref_pos
#' @aliases ref_pos.csv
#' @keywords datasets
#'
#' @usage ref_pos
#'
#' @format A data.frame with 4992 rows and 5 columns:
#' \describe{
#'   \item{barcode}{Spot barcode (e.g., "AAACGCTGAAAGCGTC-1")}
#'   \item{x}{X-coordinate on the capture area}
#'   \item{y}{Y-coordinate on the capture area}
#'   \item{x-pixel}{Y-pixel on the capture area}
#'   \item{y-pixel}{Y-pixel on the capture area}
#'}
#'
#' @source
#' <https://github.com/ucagenomix/SiT>
NULL

ref_pos <- function() {
  path <- system.file("extdata", "ref_pos.csv", package = "stPipe")
  read.csv(path, stringsAsFactors = FALSE)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' @name RunDemultiplex
NULL

RunDemultiplex <- function(read_1_fq_path, read_2_fq_path, h5_mapping_path, output_fq_path, n_reads, coord_bc_start, coord_bc_len, umi_start, umi_len, bin_size = 1L) {
    invisible(.Call(`_stPipe_RunDemultiplex`, read_1_fq_path, read_2_fq_path, h5_mapping_path, output_fq_path, n_reads, coord_bc_start, coord_bc_len, umi_start, umi_len, bin_size))
}

#####################################################
# Perform QC filtering for sST preliminary results
#####################################################

#' @name Run_QC
#' @title QC Control After Upstream Pre-Processing for Sequencing-Based Spatial Transcriptomics
#' @details
#'
#' This function performs QC control on sequencing-based spatial transcriptomics data after upstream pre-processing step such as 'Run_ST' step. Ensure the output directory is the same with the 'Run_ST' one.
#' Filtering is performed either use specific UMI threshold or assign the threshold to 'DropletUtils'.
#'
#' "max_slope"
#'
#' In this approach, the filtering is done based on UMI counts.
#' Spots with counts below a certain threshold are considered low-quality and are filtered out.
#' This method helps retain only the spots with significant transcriptomic signals, reducing noise
#' from sptos with minimal or no meaningful biological information.
#'
#' Threshold Determination:
#' The threshold in this method is computed by analyzing the distribution of UMI counts across spots,
#' and identifying the point of maximum slope in the cumulative UMI distribution curve.
#' This point often corresponds to the transition between background noise and real biological signals.
#'
#' "EmptyDropletUtils"
#'
#' Alternatively, the \code{DropletUtils} package offers a more sophisticated approach
#' by using statistical methods to identify droplets or spots that contain real cells, as opposed
#' to empty droplets or those containing background RNA. This method calculates a
#' false discovery rate (FDR) to assess the likelihood of each droplet containing a real cell. Sptos are retained if they meet the significance criteria for either the p-value or FDR.
#' To learn more details regarding \code{DropletUtils}, visit
#' \href{https://bioconductor.org/packages/release/bioc/html/DropletUtils.html}{this link to its Bioconductor page}.
#'
#' Multiple Thresholds:
#' This method will determine two thresholds based on the config file input parameters.
#' Filtering can be fine-tuned using both p-value and FDR thresholds, offering greater flexibility in distinguishing between noise and meaningful data.
#' Sptos are retained if they meet the significance criteria for either the p-value or FDR.
#' @param config Path to the YAML configuration file.
#' @param matched.data A data frame containing spatial transcriptomics data, including UMI counts and spatial coordinates, this is usually obtained from 'Run_loc_match' function.
#' @param gene.matrix A gene count matrix, this is usually obtained from 'Run_ST' function.
#' @param show.config Logical value indicating whether to print the configuration. Defaults to TRUE.
#' @export
#' @return A list containing filtered gene counts with matched spatial coordinates after QC.
#' @examples
#' output_dir <- tempdir()
#' config_list <- list(
#' output_directory = output_dir,
#' qc_filter = "slope_max",
#' qc_per = "0.4_0.8"
#' )
#' config_path <- tempfile(fileext = ".yml")
#' yaml::write_yaml(config_list, config_path)
#' set.seed(123)
#' gene_ids <- paste0("gene", seq_len(100))
#' spatial_names <- paste0("SPATIAL_", seq_len(100))
#' count_matrix <- matrix(rpois(100*100, lambda = 20), nrow = 100, ncol = 100)
#' colnames(count_matrix) <- spatial_names
#' gene_matrix <- data.frame(row.names = gene_ids, count_matrix, stringsAsFactors = FALSE)
#' matched_data <- data.frame(
#'  X_coordinate = runif(100, min = 0, max = 1000),
#'  Y_coordinate = runif(100, min = 0, max = 1000),
#'  barcode_sequence = paste0("BC", seq_len(100)),
#'  spatial_name = spatial_names,
#'  stringsAsFactors = FALSE
#' )
#' umi_counts <- colSums(gene_matrix[, -1])
#' matched_data$UMI_count <- umi_counts[match(matched_data$spatial_name, names(umi_counts))]
#' qc_results <- Run_QC(
#'  config = config_path,
#'  matched.data = matched_data,
#'  gene.matrix = gene_matrix,
#'  show.config = FALSE
#' )
#' @importFrom ggplot2 ggplot scale_fill_brewer aes geom_bar geom_text theme_minimal theme labs ggsave element_text geom_point scale_color_gradient element_blank element_rect xlim ylim geom_segment geom_line geom_hline arrow unit
#' @importFrom dplyr %>%
#' @importFrom stats quantile na.omit

if (getRversion() >= "2.15.1") {
  utils::globalVariables("Percentile")
}

Run_QC <- function(config, matched.data, gene.matrix, show.config = TRUE) {

  config <- yaml::read_yaml(config)
  if (show.config) {
    message(config)
  }

  output_directory <- as.character(config$output_directory)
  qc_filter <- as.character(config$qc_filter)
  qc_per <- unlist(strsplit(config$qc_per, "_"))
  qc_per_lower <- as.numeric(qc_per[1])
  qc_per_retain <- as.numeric(qc_per[2])

  # New directory named 'upstream_QC' under output directory
  qc_dir <- file.path(output_directory, "upstream_QC")
  if (!dir.exists(qc_dir)) {
    dir.create(qc_dir)
  }
  gene_count <- gene.matrix
  sum_counts <- colSums(gene_count[, -1])
  spatial_coords <- matched.data[, c("X_coordinate", "Y_coordinate", "barcode_sequence", "spatial_name")]

  # Barcode quality filtering
  quantiles <- quantile(sum_counts, probs = seq(0, 1, 0.01))
  quantile_df <- data.frame(
    Percentile = seq(0, 100, 1),
    Value = as.numeric(quantiles)
  )
  quantile_df$Slope <- c(NA, diff(quantile_df$Value) / diff(quantile_df$Percentile))
  max_slope_index <- which.max(quantile_df$Slope[-1]) + 1  # first slope is NA
  max_slope_interval <- quantile_df[max_slope_index - seq_len(max_slope_index), ]
  max_slope_interval <- max_slope_interval[max_slope_interval$Slope < quantile(na.omit(quantile_df$Slope), qc_per_retain)[[1]], ]
  max_slope_interval <- max_slope_interval[max_slope_interval$Value < quantile(na.omit(quantile_df$Value), qc_per_retain)[[1]], ]
  max_slope_interval2 <- max_slope_interval
  max_slope_interval2 <- max_slope_interval2[max_slope_interval2$Slope < quantile(na.omit(quantile_df$Slope), qc_per_lower)[[1]], ]
  max_slope_interval2 <- max_slope_interval2[max_slope_interval2$Value < quantile(na.omit(quantile_df$Value), qc_per_lower)[[1]], ]
  max_slope_interval$SlopeIncrease <- -c(diff(max_slope_interval$Slope), NA)
  max_slope_interval2$SlopeIncrease <- -c(diff(max_slope_interval2$Slope), NA)
  threshold <- max_slope_interval$Value[which.max(max_slope_interval$SlopeIncrease)]
  ed_lower <- max_slope_interval2$Value[which.max(max_slope_interval2$SlopeIncrease)]

  # Plotting
  #
  #   p <- ggplot(quantile_df, aes(x = Percentile, y = Value)) +
  #     geom_line() +
  #     geom_point() +
  #     geom_segment(data = max_slope_interval,
  #                  aes(x = Percentile[1], y = Value[1], xend = Percentile[2], yend = Value[2]),
  #                  color = "red", linewidth = 1, arrow = arrow(type = "closed", length = unit(0.2, "inches"))) +
  #     geom_text(data = max_slope_interval,
  #               aes(x = Percentile[2], y = Value[2], label = paste("EmptyDrop Retain Threshold", round(Value[1], 2))),
  #               vjust = -1, color = "red") +
  #     geom_hline(yintercept = ed_lower, linetype = "dashed", color = "blue") +
  #     geom_text(aes(x = max(Percentile), y = ed_lower,
  #                   label = paste("EmptyDrop Lower Threshold", round(ed_lower, 2))),
  #               vjust = -1, hjust = 1.1, color = "blue") +
  #     labs(title = "Threshold to filter out low count UMI as potential background noise",
  #          x = "UMI Count Percentile", y = "Value") +
  #     theme_minimal()
  #
  #   ggsave("Threshold.pdf", plot = p, width = 10, height = 8, units = "in", device = "pdf")
  #

  # Filtering based on QC method
  if (qc_filter == "slope_max") {
    keep_cells <- sum_counts[sum_counts > threshold]
    filtered_gene_count <- gene_count[, names(keep_cells)]
  } else if (qc_filter == "EmptyDropletUtils") {
    keep_cells <- sum_counts[sum_counts > threshold]
    gene_count_ED <- gene_count
    rownames(gene_count_ED) <- gene_count_ED$gene_id
    gene_count_ED$gene_id <- NULL
    outs <- DropletUtils::emptyDrops(gene_count_ED, retain = threshold)
    is.cell <- outs$FDR <= 0.01
    is.sign <- outs$PValue <= 0.05
    is.both <- is.cell & is.sign
    filtered_gene_count <- gene_count_ED[, which(is.both), drop = FALSE]
  }

  spatial_coords <- spatial_coords[spatial_coords$spatial_name %in% names(keep_cells) & spatial_coords$spatial_name %in% colnames(filtered_gene_count), ]
  spatial_coords$UMI_count <- sum_counts[spatial_coords$spatial_name]

  return(list(filtered_gene_count = filtered_gene_count, filtered_spatial_coords = spatial_coords))
}

test_that("pseudo-output has correct structure", {
  
  # 1) matched_data pseudo
  matched_data <- data.frame(
    barcode_sequence = c("B1", "B2", "B3"),
    spatial_name     = c("SPATIAL_1", "SPATIAL_2", "SPATIAL_3"),
    X_coordinate     = c(10, 20, 30),
    Y_coordinate     = c(40, 50, 60),
    UMI_count        = c(1+2+3, 4+5+6, 7+8+9),  # sums of gene counts per 
    stringsAsFactors = FALSE
  )
  
  # 2) gene_count pseudo
  gene_count <- data.frame(
    SPATIAL_1 = c(1, 2, 3),
    SPATIAL_2 = c(4, 5, 6),
    SPATIAL_3 = c(7, 8, 9),
    row.names     = c("gA", "gB", "gC"),
    stringsAsFactors = FALSE,
    check.names   = FALSE
  )
  
  # 3) Tests on matched_data
  expect_s3_class(matched_data, "data.frame")
  expect_equal(nrow(matched_data), 3)
  expect_true(all(c(
    "barcode_sequence", "spatial_name",
    "X_coordinate", "Y_coordinate", "UMI_count"
  ) %in% colnames(matched_data)))
  # Check UMI counts
  expect_equal(matched_data$UMI_count, c(6, 15, 24))
  
  # 4) Tests on gene_count
  expect_s3_class(gene_count, "data.frame")
  expect_equal(nrow(gene_count), 3)
  expect_equal(rownames(gene_count), c("gA", "gB", "gC"))
  expect_true(all(grepl("^SPATIAL_", colnames(gene_count))))
  expect_equal(gene_count["gB", "SPATIAL_2"], 5)
  
})

---
title: "stPipe: A flexible and streamlined pipeline for processing sequencing-based spatial transcriptomics data"
author: "Yang Xu"
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
runtime: shiny
vignette: >
  %\VignetteIndexEntry{stPipe: A flexible and streamlined pipeline for processing sequencing-based spatial transcriptomics data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Introduction to `stPipe` package
`stPipe` is a package designed to process sequencing-based spatial transcriptomics (sST) data generated by different platforms, including 10X Visium, BGI Stereo-seq, and Slide-seq/Curio-seeker. `stPipe` consists of two major components. The first is data pre-processing with paired-end FASTQ files as input and a gene count matrix with matched spatial information as output. The second component takes the pre-processing results as input and performs quality control, downstream object construction and generates an HTML report for overall summary.

## Platform introduction 1: 10X Visium
10X Genomics' Visium platform is one of the most widely adopted methods for sST, offering high-throughput capabilities and compatibility with diverse tissue types. Visium is developed based on the original spatial transcriptomics technology via positioning histological sections on arrayed reverse transcription primers with unique positional barcodes. Visium supports both fresh frozen (FF) and formalin-fixed, paraffin-embedded (FFPE) tissues. Tissue processing can be performed manually or via the automated CytAssist system. Two distinct mRNA capture methodologies are available: probe-based and poly-A-based methods. Visium offers two capture area configurations: 6.5 x 6.5 mm area comprising 4,992 spots and an 11 x 11 mm area containing 14,336 spots. Each spot is 55 µm in diameter, with a center-to-center distance of 100 µm. Recent available Visium HD provides an enhanced spatial resolution of 2 µm without any gaps between.

## Platform introduction 2: Slide-seq / Curio-seeker
Slide-seq uses a method whereby RNA from tissue sections is transferred onto a surface embedded with DNA-barcoded 10 µm beads. The random distribution of beads across the surface results in variable distances between barcodes. Notably, the spatial barcode in Slide-seq is divided into two segments by a linker sequence. Slide-seq V2 modifies the library generation, bead synthesis, and array indexing steps to improve the mRNA capture sensitivity by approximately 10-fold over the original Slide-seq V1 method. Slide-seq has been commercialized as Curio Seeker by Curio Bioscience. 

## Platform introduction 3: BGI Stereo-seq
Based on DNA nanoball (DNB) technology, BGI Stereo-seq (SpaTial Enhanced REsolution Omics-sequencing) resolves the sequencing data via 1 x 1 cm RNA capture unit on the STOmics-GeneExpression Chip. The original DNA nanoball sequencing amplifies small fragments of genomic DNA into DNA nanoballs via rolling circle replication with fluorescent nucleotides binding to complementary nucleotides that are polymerized to anchor sequences bound to known sequences on the DNA template. In the refined Stereo-seq protocol, DNBs are generated by rolling circle amplification of circularized DNA oligonucleotides, forming spherical structures. Each DNB carries a 25-nt coordinate identity (CID) used to identify its spatial position during RNA capture and sequencing. Then the spatial location of each DNB is recorded with diameter of 0.2um and a center-to-center distance of 0.5um which allows for sub-cellular single-cell resolution data. 

## Table Summary for mainstream sST platforms
```{r, summary, echo=FALSE}
table_data <- data.frame(
  Protocol = c("Visium", "Visium HD", "Slide-seq/Curio-seeker", "Stereo-seq", "Curio-seeker"),
  Resolution_micron = c(50, 2, 10, 10, 10),
  Spot_distance_micron = c(100, "0 (no gaps)", 10, 0.5, 10),
  Typical_array_size = c("0.65cm x 0.65cm / 1.1cm x 1.1cm", 
                         "0.65cm x 0.65cm / 1.1cm x 1.1cm", 
                         "/", 
                         "1cm x 1cm; (max: 13.2cm x 13.2cm)", 
                         "0.3cm x 0.3cm / 1cm x 1cm")
)

knitr::kable(table_data, format = "markdown", col.names = c("Protocol", "Resolution (micron)", "Spot distance (micron)", "Typical array size"))
```
# figure
## Case Study 1: Preprocessing 10X Visium data
The sample data used for this study is from a FFPE mouse spleen performed using 10x Visium's probe based assay. It has been downsampled for computing efficiency.
All files can be found in the `extdata` folder of the `stPipe` package. The original data comes from the `SpatialBenchVisium` project and is available under GEO accession number GSE254652, detailed in [Spotlight on 10x Visium: a multi-sample protocol comparison of spatial technologies](https://www.biorxiv.org/content/10.1101/2024.03.13.584910v1.abstract). 

## Getting started

We begin by filling in specific details of this particular sample in the config file. Note it is important to read the explanation inside the sample config file as we will be using it for the majority of `stPipe` implemented functions.

`stPipe` implements different strategies to cope with corresponding platform features, hence the config file needs to be filled in correctly before running `stPipe`. This will be further explained in the following sections.

```{r, setup, message=FALSE}
library(stPipe)
config <- system.file("config", "config_stPipe.yml", package = "stPipe")
yaml_content <- readLines(config)
cat(yaml_content, sep = "\n")
```

## Organising config file & data for `stPipe::Run_ST`

The implemented `Run_ST` function streamlines multiple steps into one cohesive process, including FASTQ or BAM file reformatting where barcodes and UMI information are extracted and incorporated into the read headers, read alignment, barcode demultiplexing, and gene counting. `stPipe` performs different strategies for probe-based and polyA-based protocols, the former one utilizes probe set version to construct annotation files such as fa and GFF3 files while the latter one relies the annotation files specified by the user. 

The read structure for 10X Visium has the 8 bp long spatial barcode starting at position 6 and the 6 bp long UMI sequence starting at the first position. So the read structure will be : `list(bs1=-1, bl1=0, bs2=6, bl2=8, us=0, ul=6)`. `bs1=-1, bl1=0` means we don't have an index in read 1 so we set a negative value as its start position and give it zero length. `bs2=6, bl2=8` means we have an index in read two which starts at position 6 in the read and is 8 bases in length. `us=0, ul=6` means we have a UMI at the start of read 2 which is 6 bases long. **NOTE**: we use a zero based index system, so the indexing of the sequence starts at zero.

We begin by creating a temporary folder to download the demo data.

```{r, input}
# FASTQ file path:
data_directory <- file.path(tempdir(), "stPipe_demo_data")
if (!dir.exists(data_directory)) {
  dir.create(data_directory, recursive = TRUE)
}
options(timeout = 600)
R1_url <- "https://zenodo.org/records/14920583/files/stPipe_demo_R1.fq.gz?download=1"
R2_url <- "https://zenodo.org/records/14920583/files/stPipe_demo_R2.fq.gz?download=1"
R1_path <- file.path(data_directory, "stPipe_demo_R1.fq.gz")
R2_path <- file.path(data_directory, "stPipe_demo_R2.fq.gz")
download.file(R1_url, R1_path)
download.file(R2_url, R2_path)
config <- system.file("config", "config_stPipe.yml", package = "stPipe")
config <- yaml::read_yaml(config)
config$data_directory <- data_directory
```

We then create a temporary directory to store results before we're ready to run Run_ST and adjust some config information for this sample. **NOTE**: In most functions there will be a flag called `show.config` which simply prints all config information and helps you make sure that everything is configured correctly and reduces the risk of encountering issues later.

```{r, yaml, eval=TRUE}
output_directory <- file.path(tempdir(), "stPipe_output")
if (!dir.exists(output_directory)) {
  dir.create(output_directory, recursive = TRUE)
}
config$output_directory <- output_directory
demo_config_path <- tempfile(fileext = ".yml")
yaml::write_yaml(config, demo_config_path)
```

Now `stPipe` is ready to run.

```{r, Run_ST,eval=TRUE}
Run_ST(config = demo_config_path, show.config = FALSE)
```

## Organising config file for `stPipe::Run_Loc_Match`

The `Run_Loc_Match` function is responsible for pairing the gene expression matrix with match spatial locations. The key input in the config file is **technology_version** which specifies the used platform. In further segmentation, each platform has its own argument: Visium needs **visium_coordinates** to match internally stored spatial coordinates system and **image_path** is optional for pixel computation; Slide-seq/Curio-seeker needs **bead_location** which should be a `.csv` file with three columns, where the first column has the spatial barcode sequence, the second column contains the X coordinate, and the third column contains the Y coordinate to match bead location across the spatial dimension. Stereo-seq only requires **technology_version**.

```{r, Run_Loc_Match, eval=TRUE}
st.result <- Run_Loc_Match(config = demo_config_path, pixel = FALSE, show.config = FALSE)
head(st.result$matched_data)
```

## Organising config file for `stPipe::Run_QC`

At this stage, the pre-processing work is almost done. But under specific case, you might want to do some QC filtering, for example, to clean up background noise in 10X Visium scenario. The `Run_QC` function helps with this purpose.

```{r, qc, eval=TRUE}
# adjust some parameter and update the config file
config$qc_per <- c("0.4_0.6")
yaml::write_yaml(config, demo_config_path)
```

Under this filtering criteria, more than 65% of the original spots are lost which might be concerning.

```{r, Run_QC, eval=TRUE, warning=FALSE}
qc.results <- Run_QC(config = demo_config_path, matched.data = st.result$matched_data, gene.matrix = st.result$gene_count, show.config = FALSE)
dim(qc.results$filtered_spatial_coords)[1]/dim(st.result$matched_data)[1]
```

## Organising config file for `stPipe::Run_Clustering`

Once you are satisfied with the data, the `Run_Clustering` function can be utilized to perform some preliminary clustering analysis, including UMAP and T-SNE. The clustering function itself prints message every 50 iteration, to avoid long printout only 15 are shown.

```{r, Run_Clustering, eval=TRUE}
output <- capture.output(
  Cluster.results <- Run_Clustering(
    gene.count = st.result$gene_count,
    matched.data = st.result$matched_data,
    num_clusters = 5
  )
)
cat(output[seq_along(1:15)], sep = "\n")
```

## Organising config file for `stPipe::Run_Interactive`

Previously the `Run_QC` function serves as a step to get rid of spatial locations with low quality reads, but sometimes you might want to select a specific spatial region and perform further analysis. In this case, consider to use the `Run_Interactive` function which provides you with an interactive R shiny interface for personalized selection.

```{r, Run_Interactive, eval=TRUE}
 Run_Interactive(
   matched_data = st.result$matched_data,
   clustering_result = Cluster.results$tsne_df,
   background_img = NULL,
   reduction_method = "tsne",
   point_size = 1
)
```

## Organising config file for `stPipe::Run_Visualization`

`Run_Visualization` is the step where you want to check how the data looks like after a series of pre-processing steps. This function contains two flags for visualization, `Vis.spatial` and `Vis.read` corresponds to spatial visualization and sequencing visualization respectively. The former one contains UMI heatmap in raw value and log format. The latter includes barcode demultiplexing statistics, distribution of UMI duplication numbers, and alignment statistics.

```{r, Run_Visualization, eval=TRUE}
Vis.results <- Run_Visualization(
  matched.data = st.result$matched_data,
  config = demo_config_path,
  Vis.spatial = TRUE,
  Vis.read = TRUE,
  show.config = FALSE
)
```

***Barcode demultiplexing statistics*** this can suggest the percentage of reads that uniquely match to the spatial barcodes, as well as the unmatched proportion of reads and their alignment rates to introns and exons.

```{r, demultiplex_plot, eval=TRUE, fig.height=7, fig.width=7}
Vis.results$demultiplex_plot
```

***Mapping statistics***  this plot shows the mapping quality of sample. In this demo case, the 10X Visium data is generated as probe-based, hence either mapped to exon or unaligned will be observed. For polyA-based protocols, mixed variable should be expected. 

```{r, mapping_plot, eval=TRUE, fig.height=7, fig.width=7}
Vis.results$mapping_plot
```

***Spatial UMI Plot*** this is plotted as both raw and log UMI count format, suggesting the UMI spatial distribution across the captured tissue.

```{r, UMI_plot, echo=FALSE, fig.show='hold', fig.height=5, fig.width=5}
Vis.results$raw_UMI_plot
Vis.results$log_UMI_plot
```

## Summary report and downstream object

After all the previous work, a HTML report in RMarkDown format can be generated to summarize your data and save it for further documentation archive purposes. The `Run_HTML` function can help with this. **NOTE**: You will need to include ALL previous outputs to ensure the successful operation of this function.

Upstream pre-processing is never the end of exploring data in research, the `Run_Create_Obj` function is designed for further downstream analysis, catering for different pipelines such as `r BiocStyle::CRANpkg("Seurat")`, `r BiocStyle::Githubpkg("scverse/squidpy")`, and `r BiocStyle::Biocpkg("SpatialExperiment")` supported bioconductor packages.

```{r, seu_obj}
library(Seurat)
library(SeuratObject)
seu <- Run_Create_Obj(
   gene.matrix = st.result$gene_count,
   matched.data = st.result$matched_data,
   obj.type = 'Seurat',
   tech = 'Visium'
 )
seu
```


<details>
<summary>Session Info</summary>
```{r, sessionInfo}
sessionInfo()
```

---
title: "stPipe Report"
output: 
  html_document:
    toc: true             
    toc_depth: 3          
    toc_float: true     
---

# Summary of Results

This HTML report provides an overview of the outputs generated by **stPipe** package and serves as a guide to help understand the filtering approaches and their impact on data quality, providing a foundation for confident downstream analysis. Below you can find each visualization results with corresponding explanation for your data in different sections.

## Barcode demultiplexing Plot

The barcode demultiplexing plot shows the percentage of reads that uniquely match to the cell barcodes, as well as the unmatched proportion of reads and their alignment rates to introns and exons. 

### Importance

If a large proportion of unmatched reads is observed that map to exons, a failure of the spatial barcode demultiplexing is possible.

```{r, echo=FALSE, fig.align="center", fig.cap="Fig 1. Barcode demultiplexing Plot"}
knitr::include_graphics('<<Barcode_demultiplexing_plot>>')

```

## UMI duplication Plot

The UMI duplication plot is used to evaluate read depth. In this plot, X axis and Y axis stands for log UMI duplication number and frequency respectively.

### Importance

UMIs are routinely used to mark individual molecules and after PCR amplification, the same molecule with have multiple copys, which can be identified and removed if they are observed to have the same UMI sequence. UMI copy number is an indication of the PCR amplification rate.

```{r, echo=FALSE, fig.align="center"}
knitr::include_graphics('<<UMI_duplication_plot>>')

```

## Mapping Statistics Plot

The mapping statistics plot  X axis presents the position across all spots/bins/beads/nanoballs and Y axis presents the percentage of reads corresponding to 6 categories, including "unaligned", "aligned_unmapped", "ambiguous_mapping", "mapped_to_ERCC", "mapped_to_intron", and "mapped_to_exon."

### Importance

This alignment statistics is often used as an important indictor for mapping quality.

```{r, echo=FALSE, fig.align="center"}
knitr::include_graphics(normalizePath('<<Mapping_statistics_plot>>'), error = FALSE)
```

## Threshold for **'Run_QC'** step

This threshold plot quantile raw UMI count as 100 percentiles in the X axis, raw UMI count showing in the Y axis. Detailed description can be found in **'Run_QC'** help page.

#### Visual Representation:
The QC process generates a plot showing UMI count percentiles, with annotations for the threshold values used to filter low-count cells. This visualization aids in understanding the filtering process.

### Impoatance
This plot is necessary to check for QC, as it would directly show you the raw UMI count quality and provides the thresholds used within **stPipe**. You could further adjust and personalize your **qc_per** in the config file according to this plot.

```{r, echo=FALSE, fig.align="center"}
knitr::include_graphics(normalizePath('<<Threshold>>'), error = FALSE)
```

## UMI Count Spatial Heatmap

This section shows two spatial heatmap with the left one showing raw UMI count and right one showing log UMI count. Both of them present the spatial distribution of UMI count, you may wish to visualize them before and after **'Run_QC'** step.

### Importance

This spatial heatmap provides direct visualization in the perspective of raw and log UMI count. For 10X Visium, this suggests the tissue appearance. For other technologies such as Slideseq, this shows the density of UMI distribution in spatial dimension. 

```{r, echo=FALSE, fig.show='hold', out.width="50%", out.height="400px", dpi=400}
knitr::include_graphics('<<Spatial_Heatmap_of_UMI_Count_raw>>')
knitr::include_graphics('<<Spatial_Heatmap_of_UMI_Count_log>>')
```

## Spatial location number before and after **'Run_QC'** step

The number of spots/bins/beads/nanoballs before and after the **'Run_QC'** step is critical. For 10X Visium, **'Run_QC'** step aims to remove the background noise outside the captured tissue. For other technologies such as Slideseq, **'Run_QC'** step aims to remove low quality spatial location which would not impact further downstream analysis.

### Importance

It is important to get information from the spatial locations removed by **'Run_QC'**, since doing quality control is a kind of "fine tuning" process - you don't want to remove too much information but do want to get rid of nosiy data.

# Clustering: T-SNE and UMAP

### Importance
T-SNE visually reveals the clustering patterns in the data, helping you to determine whether distinct groups or clusters exist. It is especially useful for identifying dense regions of the data and showing their relationships in spatial distribution, providing insights that can be used for further biological interpretation.

```{r, echo=FALSE, fig.align="center"}
knitr::include_url('<<tsne_interactive>>')
```

### Importance

UMAP complements T-SNE by displaying global trends in the data, allowing you to observe the relative positioning of different groups or clusters and identify potential transitions between them. Additionally, UMAP is often used in large-scale datasets to reduce dimensionality and visualize characteristic patterns across spatial or single-cell data.

```{r, echo=FALSE, fig.align="center"}
knitr::include_url('<<umap_interactive>>')
```

<details>
<summary>Session Info</summary>
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_Create_Obj.R
\name{Run_Create_Obj}
\alias{Run_Create_Obj}
\title{This function creates specified spatial transcriptomics data object for further personalized downstream analysis}
\usage{
Run_Create_Obj(gene.matrix, matched.data, obj.type, tech, ss.radius = 3000)
}
\arguments{
\item{gene.matrix}{Gene count matrix. This is usually obtained from 'Run_ST' function.}

\item{matched.data}{Data frame which contains spatial localization matched with gene count matrix. This is usually obtained from 'Run_loc_match' function.}

\item{obj.type}{Type of spatial transcriptomics object being created, can be 'Seurat', 'SpatialExperiment', or 'AnnData'.}

\item{tech}{Type of spatial transcriptomics sequencing technology, can be "Visium", "Slideseq", "Curio-seeker", or "Stereoseq".}

\item{ss.radius}{Optional. Radius for filtering SlideSeq or Curio-seeker spots for Seurat object. Default is 3000.}
}
\value{
Created spatial transcriptomics data object as required by 'obj.type'.
set.seed(123)
gene.count <- matrix(sample(0:100, 200*100, TRUE), nrow=200)
rownames(gene.count) <- paste0('Gene', 1:200)
colnames(gene.count) <- paste0('Spot', 1:100)
matched.data <- data.frame(
  spatial_name = colnames(gene.count),
  barcode_sequence = paste0('BC', 1:100),
  X_coordinate = runif(100,0,10),
  Y_coordinate = runif(100,0,10),
  UMI_count = sample(50:200,100,TRUE)
)
seu <- Run_Create_Obj(
  gene.matrix = gene.count,
  matched.data = matched.data,
  obj.type = 'Seurat',
  tech = 'Slideseq'
)
}
\description{
This function creates specified spatial transcriptomics data object for further personalized downstream analysis
}
\details{
Current mainstream analytic tools for downstream includes: Seurat, SpatialExperiment supported tools, and Squidpy.
This function can help creates corresponding objects for further downstream analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_HTML.R
\name{Run_HTML}
\alias{Run_HTML}
\title{HTML report generation in RMarkDown format}
\usage{
Run_HTML(path)
}
\arguments{
\item{path}{Path to where results are stored, including the ones obtained from 'Run_ST', 'Run_loc_match', 'Run_Vis', and 'Run_Clustering'.}
}
\value{
Generated HTML report in RMarkDown format.
}
\description{
This function generates a HTML report of stPipe upstream processing steps in Rmarkdown format. It extracts plots in the result directory and outputs them in the whole report with corresponding explanation.
}
\examples{
## @example
temp_dir <- tempdir()
dummy_gene_count <- data.frame(GeneA = c(10, 20), GeneB = c(5, 15))
rownames(dummy_gene_count) <- c("spot1", "spot2")
write.csv(dummy_gene_count, file = file.path(temp_dir, "gene_count.csv"), row.names = TRUE)
png_files <- c("Mapping_statistics_plot.png", "UMI_duplication_plot.png", 
             "Barcode_demultiplexing_plot.png", "Spatial_Heatmap_of_UMI_Count_raw.png", 
                         "Spatial_Heatmap_of_UMI_Count_log.png", "Threshold.png")
                         for (f in png_files) {
                           fileConn <- file(file.path(temp_dir, f))
                             writeLines("dummy image content", fileConn)
                               close(fileConn)}
html_files <- c("tsne_interactive.html", "umap_interactive.html")
for (f in html_files) {
 fileConn <- file(file.path(temp_dir, f))
 writeLines("<html>dummy interactive html</html>", fileConn)
 close(fileConn)}
dummy_rmd <- paste(
 "Report for stPipe",
 "Mapping Statistics: <<Mapping_statistics_plot>>",
 "UMI Duplication: <<UMI_duplication_plot>>",
 "Barcode Demultiplexing: <<Barcode_demultiplexing_plot>>",
 "Spatial Heatmap Raw: <<Spatial_Heatmap_of_UMI_Count_raw>>",
 "Spatial Heatmap Log: <<Spatial_Heatmap_of_UMI_Count_log>>",
 "Threshold: <<Threshold>>",
 "tSNE Interactive: <<tsne_interactive>>",
 "UMAP Interactive: <<umap_interactive>>",
 sep = "\n"
)
dummy_template_path <- file.path(temp_dir, "stPipe_Report_Skeleton.Rmd")
writeLines(dummy_rmd, dummy_template_path)
Run_HTML_test <- function(path) {
 rmd_template_path <- dummy_template_path
 if (rmd_template_path == "") {
   stop("Template file not found. Please check if it's properly installed in your package.")
 }
rmd_template <- readLines(rmd_template_path)
 gene_count <- read.csv(file.path(path, "gene_count.csv"), row.names = 1)
   Mapping_statistics_plot <- normalizePath(file.path(path, "Mapping_statistics_plot.png"))
 UMI_duplication_plot <- normalizePath(file.path(path, "UMI_duplication_plot.png"))
 Barcode_demultiplexing_plot <- normalizePath(file.path(path, "Barcode_demultiplexing_plot.png"))
 Spatial_Heatmap_of_UMI_Count_raw <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_raw.png"))
 Spatial_Heatmap_of_UMI_Count_log <- normalizePath(file.path(path, "Spatial_Heatmap_of_UMI_Count_log.png"))
 Threshold <- normalizePath(file.path(path, "Threshold.png"))
 tsne_interactive <- normalizePath(file.path(path, "tsne_interactive.html"))
 umap_interactive <- normalizePath(file.path(path, "umap_interactive.html"))
 rmd_content <- gsub("<<path>>", path, rmd_template)
 rmd_content <- gsub("<<Mapping_statistics_plot>>", Mapping_statistics_plot, rmd_content)
 rmd_content <- gsub("<<UMI_duplication_plot>>", UMI_duplication_plot, rmd_content)
 rmd_content <- gsub("<<Barcode_demultiplexing_plot>>", Barcode_demultiplexing_plot, rmd_content)
 rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_raw>>", Spatial_Heatmap_of_UMI_Count_raw, rmd_content)
 rmd_content <- gsub("<<Spatial_Heatmap_of_UMI_Count_log>>", Spatial_Heatmap_of_UMI_Count_log, rmd_content)
 rmd_content <- gsub("<<Threshold>>", Threshold, rmd_content)
 rmd_content <- gsub("<<tsne_interactive>>", tsne_interactive, rmd_content)
 rmd_content <- gsub("<<umap_interactive>>", umap_interactive, rmd_content)
 rmd_file <- file.path(path, "report.Rmd")
 writeLines(rmd_content, rmd_file)
 rmarkdown::render(rmd_file, output_file = file.path(path, "report.html"))}
Run_HTML_test(temp_dir)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_Clustering.R
\name{Run_Clustering}
\alias{Run_Clustering}
\title{Perform Basic Clustering Algorithms}
\usage{
Run_Clustering(gene.count, matched.data, num_clusters = 5)
}
\arguments{
\item{gene.count}{A data frame containing gene count data with gene IDs as row names.}

\item{matched.data}{A data frame containing matched spatial coordinates with raw UMI counts.}

\item{num_clusters}{Number of clusters during clustering. Default set to five.}
}
\value{
A list which contains interactive clustering visualization result with related data frames.
}
\description{
This function performs basic clustering using t-SNE and UMAP, either before or after the QC step and outputs visualizations results.
}
\details{
T-SNE (t-Distributed Stochastic Neighbor Embedding)

T-SNE is a popular dimensionality reduction technique used to project high-dimensional data into two or three dimensions.
It optimizes for preserving the local structure of the data, meaning that points that are close to each other in high-dimensional space will remain close in the lower-dimensional representation.
This method is widely used in single-cell RNA-seq and spatial transcriptomics to explore the heterogeneity of the data and identify cells or spatial regions with similar expression profiles.

UMAP (Uniform Manifold Approximation and Projection)

UMAP is another popular dimensionality reduction technique that aims to preserve both the local and global structures of the data, with a stronger emphasis on efficiency.
It excels at handling large datasets, generating low-dimensional projections in less time compared to T-SNE.
Unlike T-SNE, UMAP seeks to retain both local and global data structures, making it more suitable for capturing broad clustering patterns across the datasets.
}
\examples{
set.seed(123)
gene.count <- matrix(sample(0:100, 200 * 100, replace = TRUE), nrow = 200)
rownames(gene.count) <- paste0("Gene", seq_len(200))
colnames(gene.count) <- paste0("Spot", seq_len(100))
matched.data <- data.frame(
  spatial_name = paste0("Spot", seq_len(100)),
  x_coord = runif(100, 0, 10),
  y_coord = runif(100, 0, 10)
)
result <- Run_Clustering(
  gene.count = gene.count, 
  matched.data = matched.data, 
  num_clusters = 3
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_Visualization.R
\name{Run_Visualization}
\alias{Run_Visualization}
\title{Visualize pre-processed sST data}
\usage{
Run_Visualization(
  matched.data = NULL,
  config,
  Vis.spatial = TRUE,
  Vis.read = TRUE,
  show.config = TRUE
)
}
\arguments{
\item{matched.data}{A data frame containing spatial transcriptomics data, including UMI counts and spatial coordinates. This is usually obtained from 'Run_loc_match' function.}

\item{config}{Path to the YAML configuration file.}

\item{Vis.spatial}{Logical value indicating whether to visualize spatial data. Defaults to TRUE.}

\item{Vis.read}{Logical value indicating whether to visualize read-level data. Defaults to TRUE.}

\item{show.config}{Logical value indicating whether to print the configuration. Defaults to TRUE.}
}
\value{
A list contains spatial and read level visualization results.
}
\description{
This function visualizes both spatial-level and read-level information either before or after the 'Run_QC' step. It outputs raw and log-transformed UMI count plots for spatial flag, and demultiplexing and mapping statistics for read flag.
}
\examples{
temp_config <- tempfile(fileext = ".yml")
writeLines("technology_version: 'Visium 1.0'\noutput_directory: '.'", temp_config)
matched.data <- data.frame(
X_coordinate = runif(10, 0, 100),
Y_coordinate = runif(10, 0, 100),
UMI_count = sample(seq_len(100), 10),
spatial_name = paste0("Spot", seq_len(10)),
stringsAsFactors = FALSE
)
vis_results <- Run_Visualization(
  matched.data = matched.data, 
  config = temp_config, 
  Vis.spatial = TRUE, 
  Vis.read = FALSE, 
  show.config = FALSE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/help.R
\docType{package}
\name{stPipe}
\alias{stPipe}
\alias{stPipe-package}
\title{stPipe: A package for pre-processing sequencing-based spatial transcriptomics data.}
\description{
The stPipe will do spatial barcode demultiplexing, UMI deduplication, spatial location matching and quality control on
fastq data generated from all mainstream protocols
}
\section{stPipe functions}{

The stPipe functions Run_ST, Run_loc_match, Run_QC, Run_Vis, Run_Clustering, Run_create_obj, Run_HTML, Run_Interactive
}

\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/mritchielab/stPipe}
  \item Report bugs at \url{https://github.com/mritchielab/stPipe/issues/new}
}

}
\author{
Yang Xu <xu.ya@wehi.edu.au>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_ST.R
\name{Run_ST}
\alias{Run_ST}
\title{Pre-processing function for sequencing-based spatial transcriptomics}
\usage{
Run_ST(config, show.config = TRUE)
}
\arguments{
\item{config}{Path to the YAML configuration file.}

\item{show.config}{Logical value indicating whether to print the configuration. Defaults to TRUE.}
}
\value{
None. Outputs are saved to specified directories.
}
\description{
Pre-processing from FASTQ files to gene count matrix and extract spatial location information,
processing multiple sample is done via parallel computing. NB: for multiple samples, 'species' and 'technology_version' should be the same.
This function processes sequencing-based spatial transcriptomics data using various steps, including BAM to FASTQ conversion, trimming, index building, alignment, and barcode detection.
For Slideseq technology, the input should be BAM file and for all other technologies the input should be FASTQ file.
}
\examples{
data_path <- system.file("extdata", package = "stPipe")
output_directory <- file.path(tempdir(), "stPipe_output")
config_list <- list(
data_directory = data_path,          
output_directory = output_directory, 
technology_version = "Visium_probe_v1",       
species = "mouse",                   
scpipe_nthreads = 4,                
max_reads = 100000,                  
min_count = 10,                      
number_of_locations = 100,          
bs1= -1,     
bl1= 0,     
bs2= 0,      
bl2= 16,     
us= 16,      
ul= 12,      
ll= 0      
)
config_file <- tempfile(fileext = ".yml")
yaml::write_yaml(config_list, config_file)
Run_ST(
  config = config_file, 
  show.config = FALSE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_Loc_Match.R
\name{Run_Loc_Match}
\alias{Run_Loc_Match}
\title{Match spatial location After Pre-Processing for Sequencing-Based Spatial Transcriptomics}
\usage{
Run_Loc_Match(config, pixel = FALSE, show.config = TRUE)
}
\arguments{
\item{config}{Path to the YAML configuration file.}

\item{pixel}{Computing spot pixel or not. If yes, compute pixel for each spot and map back to image; if not, map the Visium coordination system. Defaults to FALSE.}

\item{show.config}{Logical value indicating whether to print the configuration. Defaults to TRUE.}
}
\value{
A data frame contains gene count matrix with spatial coordinates
}
\description{
This function matches spatial coordinates for sST data after upstream pre-processing.
'Run_loc_match' can either map the technology coordination system (such as spot in Visium coordination, bead in Slide-seq coordination)
or compute pixel for each spot and map the pixel information back to the image (only for Visium)
}
\examples{
data_dir <- tempdir()
output_dir <- file.path(tempdir(), "Run_Loc_Match_output")
if (!dir.exists(output_dir)) dir.create(output_dir, recursive = TRUE)
sample_index <- data.frame(
  barcode_sequence = c("BC001", "BC002", "BC003"),
  cell_name = c("CELL_1", "CELL_2", "CELL_3"),
  stringsAsFactors = FALSE
)
write.csv(sample_index, file = file.path(output_dir, "sample_index.csv"), row.names = FALSE)
gene_count <- data.frame(
  gene_id = c("gene1", "gene2"),
  CELL_1 = c(10, 5),
  CELL_2 = c(20, 10),
  CELL_3 = c(30, 15),
  stringsAsFactors = FALSE
)
write.csv(gene_count, file = file.path(output_dir, "gene_count.csv"), row.names = FALSE)
config_list <- list(
  output_directory = output_dir,
  data_directory = data_dir,
  technology_version = "Visium_probe_v1",
  visium_coordination = "V1"
)
config_file <- tempfile(fileext = ".yml")
yaml::write_yaml(config_list, config_file)
result <- Run_Loc_Match(
  config = config_file, 
  pixel = FALSE, 
  show.config = FALSE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_QC.R
\name{Run_QC}
\alias{Run_QC}
\title{QC Control After Upstream Pre-Processing for Sequencing-Based Spatial Transcriptomics}
\usage{
Run_QC(config, matched.data, gene.matrix, show.config = TRUE)
}
\arguments{
\item{config}{Path to the YAML configuration file.}

\item{matched.data}{A data frame containing spatial transcriptomics data, including UMI counts and spatial coordinates, this is usually obtained from 'Run_loc_match' function.}

\item{gene.matrix}{A gene count matrix, this is usually obtained from 'Run_ST' function.}

\item{show.config}{Logical value indicating whether to print the configuration. Defaults to TRUE.}
}
\value{
A list containing filtered gene counts with matched spatial coordinates after QC.
}
\description{
QC Control After Upstream Pre-Processing for Sequencing-Based Spatial Transcriptomics
}
\details{
This function performs QC control on sequencing-based spatial transcriptomics data after upstream pre-processing step such as 'Run_ST' step. Ensure the output directory is the same with the 'Run_ST' one.
Filtering is performed either use specific UMI threshold or assign the threshold to 'DropletUtils'.

"max_slope"

In this approach, the filtering is done based on UMI counts.
Spots with counts below a certain threshold are considered low-quality and are filtered out.
This method helps retain only the spots with significant transcriptomic signals, reducing noise
from sptos with minimal or no meaningful biological information.

Threshold Determination:
The threshold in this method is computed by analyzing the distribution of UMI counts across spots,
and identifying the point of maximum slope in the cumulative UMI distribution curve.
This point often corresponds to the transition between background noise and real biological signals.

"EmptyDropletUtils"

Alternatively, the \code{DropletUtils} package offers a more sophisticated approach
by using statistical methods to identify droplets or spots that contain real cells, as opposed
to empty droplets or those containing background RNA. This method calculates a
false discovery rate (FDR) to assess the likelihood of each droplet containing a real cell. Sptos are retained if they meet the significance criteria for either the p-value or FDR.
To learn more details regarding \code{DropletUtils}, visit
\href{https://bioconductor.org/packages/release/bioc/html/DropletUtils.html}{this link to its Bioconductor page}.

Multiple Thresholds:
This method will determine two thresholds based on the config file input parameters.
Filtering can be fine-tuned using both p-value and FDR thresholds, offering greater flexibility in distinguishing between noise and meaningful data.
Sptos are retained if they meet the significance criteria for either the p-value or FDR.
}
\examples{
output_dir <- tempdir()
config_list <- list(
output_directory = output_dir,
qc_filter = "slope_max",
qc_per = "0.4_0.8" 
)
config_path <- tempfile(fileext = ".yml")
yaml::write_yaml(config_list, config_path)
set.seed(123)
gene_ids <- paste0("gene", seq_len(100))
spatial_names <- paste0("SPATIAL_", seq_len(100))
count_matrix <- matrix(rpois(100*100, lambda = 20), nrow = 100, ncol = 100)
colnames(count_matrix) <- spatial_names
gene_matrix <- data.frame(row.names = gene_ids, count_matrix, stringsAsFactors = FALSE)
matched_data <- data.frame(
 X_coordinate = runif(100, min = 0, max = 1000),
 Y_coordinate = runif(100, min = 0, max = 1000),
 barcode_sequence = paste0("BC", seq_len(100)),
 spatial_name = spatial_names,
 stringsAsFactors = FALSE
)
umi_counts <- colSums(gene_matrix[, -1])
matched_data$UMI_count <- umi_counts[match(matched_data$spatial_name, names(umi_counts))]
qc_results <- Run_QC(
 config = config_path,
 matched.data = matched_data,
 gene.matrix = gene_matrix,
 show.config = FALSE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Run_Interactive.R
\name{Run_Interactive}
\alias{Run_Interactive}
\title{Interactive Visualization for Spatial Transcriptomics Data and spot plot with save functionality}
\usage{
Run_Interactive(
  matched_data,
  clustering_result,
  background_img = NULL,
  reduction_method = "tsne",
  point_size = 1
)
}
\arguments{
\item{matched_data}{A data frame containing matched spatial coordinates with raw UMI counts.}

\item{clustering_result}{A data frame containing matched spatial coordinates with raw UMI counts.}

\item{background_img}{Optional background H&E image.}

\item{reduction_method}{T-SNE ("tsne") or UMAP ("umap") result data frame obtained from 'Run_Clustering' function. Default set as "tsne".}

\item{point_size}{Size of point shown in the spatial heatmap. Default set as 1.}
}
\value{
R-shiny interactive webpage.
}
\description{
Interactive Visualization for Spatial Transcriptomics Data and spot plot with save functionality
}
\details{
This function generates interactive plots to visualize spatial transcriptomics data. It takes matched spatial coordinates and raw UMI counts to produce customized t-SNE or UMAP plots overlayed on a optional background H&E image.
}
\examples{
matched_data <- data.frame(
X_coordinate = runif(10, 0, 100),
Y_coordinate = runif(10, 0, 100),
UMI_count = sample(seq_len(100), 10),
spatial_name = paste0("Spot", seq_len(10)),
stringsAsFactors = FALSE
)
clustering_result <- data.frame(
TSNE1 = runif(10, -50, 50),
TSNE2 = runif(10, -50, 50),
spot = paste0("Spot", seq_len(10)),
cluster = sample(seq_len(3), 10, replace = TRUE),
stringsAsFactors = FALSE
)
if (interactive()) {
Run_Interactive(
  matched_data = matched_data, 
  clustering_result = clustering_result, 
  background_img = NULL, 
  reduction_method = "tsne", 
  point_size = 1)
                               }
}
